SystemOrganization addCategory: #'CI-Core'!
SystemOrganization addCategory: #'CI-Core-Publishing'!
SystemOrganization addCategory: #'CI-Core-SliceSubmitter'!
SystemOrganization addCategory: #'CI-Core-Test'!
SystemOrganization addCategory: #'CI-Core-Validation'!

ComposableModel subclass: #Authentifier
	instanceVariableNames: 'gmail passwordField passwordLabel result userField userLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!Authentifier commentStamp: '<historical>' prior: 0!
An Authentifier is a UI made for specifying username and password!

!Authentifier class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
spec
<spec>

	^ SpecLayout composed
		add: #userLabel origin: 0@0 corner: 0@0 offsetOrigin: 0@0 offsetCorner: 200@25;
		add: #userField origin: 0@0 corner: 0@0 offsetOrigin: 0@25 offsetCorner: 300@50;
		add: #gmail origin: 0@0 corner: 0@0 offsetOrigin: 300@25 offsetCorner: 400@50;
		add: #passwordLabel origin: 0@0 corner: 0@0 offsetOrigin: 0@50 offsetCorner: 200@75;
		add: #passwordField origin: 0@0 corner: 0@0 offsetOrigin: 0@75 offsetCorner: 300@100;
		yourself! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
gmail
	^ gmail! !

!Authentifier methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:00'!
initialExtent

	^  (400@180)! !

!Authentifier methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/4/2012 15:05'!
initialize
	"Initialization code for Authentifier"

	super initialize.

	result := nil asValueHolder.! !

!Authentifier methodsFor: 'initialization' stamp: 'GuillermoPolito 3/19/2013 19:12'!
initializeDialogWindow: aWindow

	aWindow okAction: [ | user password |
		user := userField getText.
		password := passwordField getText.
		(user isEmpty or: [ password isEmpty ])
			ifFalse: [ result contents: (user -> password) ]].
		
	aWindow toolbar okButton 		
					keyStrokeForNextFocus: Character tab asKeyCombination;
					keyStrokeForPreviousFocus: Character tab shift asKeyCombination.
		
	aWindow toolbar cancelButton 		
					keyStrokeForNextFocus: Character tab asKeyCombination;
					keyStrokeForPreviousFocus: Character tab shift asKeyCombination.
		
	self focusOrder
		add: userField;
		add: passwordField;
		add: aWindow toolbar.! !

!Authentifier methodsFor: 'initialization' stamp: 'GuillermoPolito 3/19/2013 19:12'!
initializeWidgets 

	self instantiateModels: #(
		userLabel 			LabelModel
		userField 			TextInputFieldModel
		gmail 				LabelModel
		passwordLabel 	LabelModel
		passwordField 		TextInputFieldModel ).
				
	userLabel text: 'Username:'.
	userField 
		entryCompletion: nil;
		autoAccept: true;
		keyStrokeForNextFocus: Character tab asKeyCombination;
		keyStrokeForPreviousFocus: Character tab shift asKeyCombination;
		ghostText: 'username'.
		
	gmail text: '@gmail.com'.
	passwordLabel text: 'Password:'.
	passwordField
		autoAccept: true; 
		acceptOnCR: true;
		ghostText: 'password';
		entryCompletion: nil;
		keyStrokeForNextFocus: Character tab asKeyCombination;
		keyStrokeForPreviousFocus: Character tab shift asKeyCombination;
		beEncrypted.! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
passwordField
	^ passwordField! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
passwordLabel
	^ passwordLabel! !

!Authentifier methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:04'!
result

	^ result contents! !

!Authentifier methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:51'!
title

	^ 'Enter username and password'! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
userField
	^ userField! !

!Authentifier methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:57'!
userLabel
	^ userLabel! !

ComposableModel subclass: #IssueCreator
	instanceVariableNames: 'description issue title type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!IssueCreator commentStamp: '<historical>' prior: 0!
An IssueCreator is a UI to create a Google Issue Tracker entry!

!IssueCreator class methodsFor: 'spec' stamp: 'BenjaminVanRyseghem 7/4/2012 15:47'!
spec
<spec>

	^ SpecLayout composed
		newColumn: [:c | 
			c 
				newRow: [:r | r 
								add: #issueTitle;
								add: #type width: 150 ] height: 30;
				add: #description ];
		yourself! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:23'!
cancelled

	^ self window 
		ifNil: [ true ]
		ifNotNil: [:w | w cancelled ]! !

!IssueCreator methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/4/2012 15:59'!
createTypes

	^ #('Type-Bug' 'Type-Cleanup' 'Type-Feature')
		collect: [:e | DropListItem named: e do: []].! !

!IssueCreator methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:42'!
description
	^ description! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:13'!
initialExtent 

	^ 800@500! !

!IssueCreator methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/4/2012 15:58'!
initialize
	"Initialization code for IssueCreator"

	issue := nil asValueHolder.
	super initialize.! !

!IssueCreator methodsFor: 'initialization' stamp: 'SeanDeNigris 8/12/2012 22:00'!
initializeDialogWindow: aWindow

	aWindow okAction: [
		description accept.
		self issue ifNotNil: [:i || t desc |
			t := title getText.
			desc := description getText asString.
			(t notEmpty and: [ desc notEmpty])
				ifTrue: [
					self issue 
						labels: { type selectedItem label. 'Milestone-', SystemVersion current dottedMajorMinor };
						title: t;
						description: desc ]]].
			
	self focusOrder
		add: title;
		add: type;
		add: description;
		add: aWindow toolbar
				
	! !

!IssueCreator methodsFor: 'initialization' stamp: 'GuillermoPolito 3/19/2013 19:12'!
initializeWidgets 

	self instantiateModels: #(
		title 			TextInputFieldModel
		description 	TextModel 
		type 			DropListModel ).
					
	title 
		ghostText: 'Title';
		autoAccept: true;
		keyStrokeForNextFocus: Character tab asKeyCombination;
		keyStrokeForPreviousFocus: Character tab shift asKeyCombination;
		entryCompletion: nil;
		isCodeCompletionAllowed: false.
		
	type 
		items: self createTypes;
		keyStrokeForNextFocus: Character tab asKeyCombination;
		keyStrokeForPreviousFocus: Character tab shift asKeyCombination.
	
	description
		isCodeCompletionAllowed: false;
		text: 'ENTER DESCRIPTION HERE';
		readSelectionBlock: [ (0 to: 22) ];
		acceptBlock: [ description readSelectionBlock: [ (1 to: 0) ]]! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:55'!
issue

	^ issue contents! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:55'!
issue: anIssue

	issue contents: anIssue! !

!IssueCreator methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:43'!
issueTitle
	^ title! !

!IssueCreator methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/4/2012 15:51'!
title

	^ 'Issue Creator'! !

!IssueCreator methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 15:42'!
type
	^ type! !

ComposableModel subclass: #MorphEmbedder
	instanceVariableNames: 'morph container title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!MorphEmbedder commentStamp: '<historical>' prior: 0!
A MorphEmbedder is a Spec model which embed a morph into a window!

!MorphEmbedder class methodsFor: 'spec' stamp: 'BenjaminVanRyseghem 7/6/2012 15:54'!
spec
<spec>

	^ SpecLayout composed
		add: #container;
		yourself! !

!MorphEmbedder methodsFor: 'private' stamp: 'BenjaminVanRyseghem 7/6/2012 16:04'!
container

	^container ifNil: [ container :=  PanelMorph new
										color: Color red;
										vResizing: #spaceFill;
										hResizing: #spaceFill
										yourself ]! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:16'!
initialExtent 

	^ 800@500! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/6/2012 16:21'!
initialize
	"Initialization code for ChangesViewer"

	morph := nil asValueHolder.
	title := self class title.
	super initialize.

	! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/18/2012 17:16'!
initializeWidgets

	morph whenChangedDo: [:m | container := m ]! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:06'!
morph

	^ morph contents! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:14'!
morph: aMorph

	morph contents: aMorph.
	aMorph 
		hResizing: #spaceFill;
		vResizing: #spaceFill! !

!MorphEmbedder methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 15:59'!
result

	^ self window 
		ifNil: [ false ]
		ifNotNil: [:w | w cancelled not ]! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/6/2012 16:21'!
title

	^ title! !

!MorphEmbedder methodsFor: 'initialization' stamp: 'BenjaminVanRyseghem 7/6/2012 16:22'!
title: aString

	title := aString.
	self updateTitle.! !

!RBLintRuleTest methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 4/26/2013 14:00'!
asCIValidationRule
	^ CISmallIntRule with: self! !

Error subclass: #ChangeNotFound
	instanceVariableNames: 'change'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!ChangeNotFound commentStamp: '<historical>' prior: 0!
I am signalled if the sources for an CIChange cannot be found.!

!ChangeNotFound class methodsFor: 'signalling' stamp: 'CamilloBruni 4/14/2013 22:37'!
signalChange: aChange
	^ self new
		change: aChange;
		signal! !

!ChangeNotFound class methodsFor: 'signalling' stamp: 'CamilloBruni 4/14/2013 22:37'!
signalChange: aChange message: aMessage
	^ self new
		change: aChange;
		signal: aMessage! !

!ChangeNotFound methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 22:37'!
change
	^ change! !

!ChangeNotFound methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 22:37'!
change: anObject
	change := anObject! !

!SoupString methodsFor: '*CI-Core' stamp: 'BenjaminVanRyseghem 3/5/2013 12:39'!
rescuedText

	| map result |
	map := OrderedCollection newFrom: {
				'&amp;quot;' -> '"'.
				'&amp;apos;' -> ''''.
				'&amp;lt;' -> '<'.
				'&amp;gt;' ->'>'.
				'&quot;' -> '"'.
				'&apos;' -> ''''.
				'&lt;' -> '<'.
				'&gt;' ->'>'.
				'&amp;' -> '&'}.
				
	result := contents.
	map do: [:pair | result := result copyReplaceAll: pair key with: pair value ].
	^ result! !

!SoupTag methodsFor: '*CI-Core' stamp: 'BenjaminVanRyseghem 3/3/2013 09:31'!
rescuedText
	"Return a string containing the concatenation of the texts in the receiver. For an example, have a look at (SoupDocumentation>>#accessingText)"

	^ String streamContents: 
			[ :aStream |
				children do: [ :eachElement | 
							aStream nextPutAll: eachElement rescuedText ] ]! !

!String methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 18:03'!
asGoogleIssueComment
	^ GoogleIssueComment new
		content: self;
		author: (GoogleUser email: Author fullName);	
		yourself! !

!String methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 18:03'!
asGoogleIssueDescription
	^ self asGoogleIssueComment asDescription! !

!BlockClosure methodsFor: '*CI-Core' stamp: 'CI Validation User 5/8/2013 13:38'!
asCIChange
	^ CITestChange loadBlock: self! !

!BlockClosure methodsFor: '*CI-Core-Validation' stamp: 'ErwanDouaille 4/30/2013 17:38'!
asCIValidationRule
	^ CITestRule block: self ! !

!BlockClosure methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/17/2013 20:49'!
valueInForkedImage
	^ CIImageForker newImageDo: self. ! !

TestResult subclass: #CITestResult
	instanceVariableNames: 'currentTest maxTest currentTestCase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CITestResult commentStamp: '<historical>' prior: 0!
I am a customized test result which outputs the progress on the command line!

!CITestResult class methodsFor: 'image-evaluation' stamp: 'ErwanDouaille 5/22/2013 15:55'!
evaluate: aBlock
	^ self new; evaluate: aBlock! !

!CITestResult class methodsFor: 'image-evaluation' stamp: 'ErwanDouaille 5/22/2013 15:55'!
evaluateFromForkedImage: aBlock
	^ aBlock value! !

!CITestResult methodsFor: 'adding' stamp: 'CamilloBruni 5/9/2013 14:15'!
addError: aTestFailure
	super addError: aTestFailure.
	self
		print: aTestFailure printString 
		short: ' [FAIL]' 
		on: self stderr red ! !

!CITestResult methodsFor: 'adding' stamp: 'CamilloBruni 5/1/2013 11:51'!
addPass: aTestCase
	super addPass: aTestCase.
	self
		print: ''
		short: ' [OK]' 
		on: self stderr green ! !

!CITestResult methodsFor: 'adding' stamp: 'CamilloBruni 5/1/2013 11:57'!
addSkip: aTestCase
	super addSkip: aTestCase.
	self
		print: ''
		short: ' [SKIP]' 
		on: self stderr blue ! !

!CITestResult methodsFor: 'accessing' stamp: 'CamilloBruni 5/1/2013 11:48'!
currentTestCase
	^ currentTestCase! !

!CITestResult methodsFor: 'helper' stamp: 'CamilloBruni 5/1/2013 11:09'!
increaseTestCount
	currentTest := currentTest + 1.! !

!CITestResult methodsFor: 'initialize' stamp: 'CamilloBruni 5/1/2013 11:10'!
initialize
	"Initialization code for CommandLineTestResult"

	super initialize.

	currentTest := 0.
	maxTest := 0.! !

!CITestResult methodsFor: 'initialize' stamp: 'CamilloBruni 5/1/2013 11:10'!
maxTest
	^ maxTest! !

!CITestResult methodsFor: 'initialize' stamp: 'CamilloBruni 5/1/2013 11:11'!
maxTest: anInteger
	maxTest := anInteger! !

!CITestResult methodsFor: 'printing' stamp: 'CamilloBruni 5/11/2013 18:36'!
print: anLongErrorMesssage short: aShortString on: aStream 
	
	aStream 
		nextPutAll: anLongErrorMesssage;
		nextPutAll: aShortString.
		
	aStream
		clear; flush; lf.! !

!CITestResult methodsFor: 'printing' stamp: 'CamilloBruni 5/11/2013 17:07'!
printProgress
	| maxPositions |
	maxPositions := (self maxTest log + 1) floor.
	self stderr
		nextPut: $[;
		nextPutAll: (currentTest asString padLeftTo: maxPositions);
		nextPut: $/;
		print: self maxTest;
		nextPutAll: '] '.! !

!CITestResult methodsFor: 'printing' stamp: 'CamilloBruni 5/11/2013 17:07'!
printTestCase: aTestCase 
	self printProgress.
	self stderr print: aTestCase.! !

!CITestResult methodsFor: 'running' stamp: 'CamilloBruni 5/1/2013 11:55'!
runCase: aTestCase 
	self increaseTestCount.
	currentTestCase := aTestCase.
	self printTestCase: aTestCase.
	super runCase: aTestCase! !

!CITestResult methodsFor: 'accessing' stamp: 'CamilloBruni 5/1/2013 11:10'!
stderr
	^ VTermOutputDriver stderr! !

!Collection methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 17:59'!
do: aBlock inParallel: threadCount
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| addSyncronization finishSync threadBlock  |
	
	finishSync := Semaphore forMutualExclusion.
	threadBlock := Semaphore new.
	(threadCount max: 1) timesRepeat: [ threadBlock signal ].

	self do: [:each |
				threadBlock wait.
				[ 	aBlock value: each.
					finishSync signal.
					threadBlock signal] fork].
		"consume all signals"
	self size timesRepeat: [ finishSync wait ].
	^ self! !

!Collection methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 17:59'!
doWithIndex: aBlock inParallel: threadCount
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| addSyncronization finishSync threadBlock  |
	
	finishSync := Semaphore forMutualExclusion.
	threadBlock := Semaphore new.
	(threadCount max: 1) timesRepeat: [ threadBlock signal ].

	self doWithIndex: [:each :index |
				threadBlock wait.
				[ 	aBlock value: each value: index.
					finishSync signal.
					threadBlock signal] fork].
		"consume all signals"
	self size timesRepeat: [ finishSync wait ].
	^ self! !

!Collection methodsFor: '*CI-Core' stamp: 'Integrator 6/21/2012 17:59'!
select: aBlock inParallel: threadCount
	"Evaluate aBlock with each of the receiver's elements as the argument. 
	Collect into a new collection like the receiver, only those elements for 
	which aBlock evaluates to true. Answer the new collection."

	| addSyncronization finishSync threadBlock count addCount results|
	
	finishSync := Semaphore forMutualExclusion.
	threadBlock := Semaphore new.
	(threadCount max: 1) timesRepeat: [ threadBlock signal ].
	count := 0.
	addCount := 1.
	results := Array new: self size.
	
	^ self class streamContents: [ :stream|
		self do: [:each | |blockCount|
			threadBlock wait.
			count := count + 1.
			blockCount := count.
			[(aBlock value: each) ifTrue: [ stream nextPut: each].
				finishSync signal.
				threadBlock signal] fork].
		"consume all signals"
		count timesRepeat: [ finishSync wait ]]! !

!SocketStream methodsFor: '*CI-Core' stamp: 'CamilloBruni 5/10/2013 17:34'!
fuelNextWordsInto: aWordObject
	"This method is the same as nextWordsInto: but the restoreEndianness is only done if needed"
	self next: aWordObject basicSize into: aWordObject startingAt: 1.
	^ aWordObject! !

!SocketStream methodsFor: '*CI-Core' stamp: 'CamilloBruni 5/10/2013 17:35'!
nextBytesPutAll: aCollection
	self nextPutAll: aCollection! !

!RBCompositeLintRule class methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/17/2013 15:14'!
pharoHardLintRules
	^ self rules: ({ 
		RBUndeclaredReferenceRule.
		RBUnclassifiedMethodsRule.
		RBNoClassCommentRule. 
		RBDefinesEqualNotHashRule.
		RBEquivalentSuperclassMethodsRule.
		RBJustSendsSuperRule.
		RBSubclassResponsibilityNotDefinedRule.
		RBTempVarOverridesInstVarRule.
		RBVariableNotDefinedRule.
		RBEqualNotUsedRule.
		RBOnlyReadOrWrittenTemporaryRule.
		RBPrecedenceRule.
		RBSendsDeprecatedMethodToGlobalRule.
		RBSizeCheckRule.
		RBUnconditionalRecursionRule.
		RBUnoptimizedToDoRule.
		RBBetweenAndRule.
		RBCodeCruftLeftInMethodsRule 
	} collect: [ :each | each new ])! !

!RBCompositeLintRule class methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/17/2013 15:14'!
pharoSoftLintRules	
	^ self rules: ({			
		RBInstanceVariableCapitalizationRule.
		RBClassVariableCapitalizationRule.
		RBMissingSubclassResponsibilityRule.
		RBOverridesSpecialMessageRule.
		RBRefersToClassRule.
		RBBadMessageRule.
		RBUsesTrueRule.
		RBSendsDifferentSuperRule.
		RBInconsistentMethodClassificationRule. 
		RBInstVarInSubclassesRule.
		RBSentNotImplementedRule.
		RBLongMethodsRule.
		RBCollectionProtocolRule.
		RBConsistencyCheckRule.
		RBContainsRule. RBDetectContainsRule.
		RBEmptyExceptionHandlerRule.
		RBEndTrueFalseRule.
		RBEqualsTrueRule.
		RBExtraBlockRule.
		RBFileBlocksRule.
		RBFloatEqualityComparisonRule.
		RBLiteralArrayCharactersRule.
		RBMissingYourselfRule.
		RBModifiesCollectionRule.
		RBReturnsIfTrueRule.
		RBSearchingLiteralRule.
		RBUnnecessaryAssignmentRule.
		RBNotEliminationRule.
		RBAtIfAbsentRule.
		RBAllAnyNoneSatisfyRule.
		RBClassNameInSelectorRule 
	} collect: [ :each | each new ])! !

!RBLintRule class methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/16/2013 11:17'!
asCIValidationRule
	^ CISmallIntRule with: self new.! !

!RBLintRule class methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/16/2013 09:27'!
harden
	^ self asCIValidationRule harden! !

!RBLintRule methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/16/2013 11:17'!
asCIValidationRule
	^ CISmallIntRule with: self.! !

!RBLintRule methodsFor: '*CI-Core-Validation' stamp: 'CamilloBruni 5/16/2013 11:18'!
harden
	^ self asCIValidationRule harden! !

!GoferResolvedReference methodsFor: '*CI-Core' stamp: 'CamilloBruni 5/1/2013 11:42'!
url
	^ self repository locationWithTrailingSlash, self name! !

ClassTestCase subclass: #CIImageForkerTest
	instanceVariableNames: 'name communication'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIImageForkerTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 15:43'!
testBasicFork
	self assert: [ 1 + 5 ] valueInForkedImage equals: 6! !

!CIImageForkerTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 15:44'!
testBasicForkError
	self should: [ NotFound signal ] valueInForkedImage raise: NotFound! !

Exception subclass: #ErrorWhileCreationException
	instanceVariableNames: 'response'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!ErrorWhileCreationException commentStamp: '<historical>' prior: 0!
An ErrorWhileCreationException is an exception raised when the creation of a new issue fails!

!ErrorWhileCreationException class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 7/4/2012 14:12'!
response: response

	^ self new
		response: response;
		yourself! !

!ErrorWhileCreationException methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:11'!
response
	^ response! !

!ErrorWhileCreationException methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 14:11'!
response: anObject
	response := anObject! !

TestCase subclass: #CITestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

CITestCase subclass: #CIPublisherTest
	instanceVariableNames: 'instance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

CIPublisherTest subclass: #CICommandLinePublisherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CICommandLinePublisherTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:17'!
publisherClass
	^ CICommandLinePublisher! !

CIPublisherTest subclass: #CIComposedPublisherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIComposedPublisherTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:16'!
publisherClass
	^ CIComposedPublisher! !

!CIComposedPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 20:09'!
testConcatenation
	| publisherA publisherB composedPublisher |
	
	publisherA := CICommandLinePublisher new.
	publisherB := CIFilePublisher new.
	composedPublisher := publisherA, publisherB.
	
	self assert: composedPublisher publishers size equals: 2.	
		
	self assert: composedPublisher publishers first equals: publisherA.
	self assert: composedPublisher publishers second equals: publisherB.! !

!CIComposedPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 20:09'!
testConcatenationClasses
	| composedPublisher |
	composedPublisher := CICommandLinePublisher, CIFilePublisher.
	
	self assert: composedPublisher publishers size equals: 2.	
		
	self assert: (composedPublisher publishers first isKindOf: CICommandLinePublisher).
	self assert: (composedPublisher publishers second isKindOf: CIFilePublisher).! !

!CIComposedPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 20:12'!
testConcatenationComposedPublisher
	| publisherA publisherB composedPublisher |
	
	publisherA := CICommandLinePublisher, CICommandLinePublisher.
	publisherB := CIFilePublisher new.
	composedPublisher := publisherA, publisherB.
	
	self assert: composedPublisher publishers size equals: 3.	
		
	self assert: (composedPublisher publishers first isKindOf: CICommandLinePublisher).
	self assert: (composedPublisher publishers second isKindOf: CICommandLinePublisher).
	self assert: composedPublisher publishers third equals: publisherB.! !

!CIComposedPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 20:11'!
testConcatenationComposedPublishers
	| publisherA publisherB composedPublisher |
	
	publisherA := CICommandLinePublisher, CICommandLinePublisher.
	publisherB := CIFilePublisher, CIFilePublisher.
	composedPublisher := publisherA, publisherB.
	
	self assert: composedPublisher publishers size equals: 4.	
		
	self assert: (composedPublisher publishers first isKindOf: CICommandLinePublisher).
	self assert: (composedPublisher publishers second isKindOf: CICommandLinePublisher).
	self assert: (composedPublisher publishers third isKindOf: CIFilePublisher).
	self assert: (composedPublisher publishers fourth isKindOf: CIFilePublisher).! !

!CIComposedPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 20:17'!
testSetManager
	| composedPublisher manager|
	
	composedPublisher := CIFuelPublisher, CICommandLinePublisher, CIIssueTrackerPublisher.
	manager := CIChangeManager new.
	
	self assert: composedPublisher manager equals: nil.
	
	composedPublisher manager: manager.
	
	self assert: composedPublisher manager equals: manager.
	composedPublisher publishers do: [ :publisher|
		self assert: publisher manager equals: manager ]! !

CIPublisherTest subclass: #CIHTMLPublisherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIHTMLPublisherTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/2/2013 18:50'!
defaultContent

	^ '<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>TestEntity -- Test report</title>
</head>
<body><h1>TestEntity test succeed !! </h1>
</body>
</html>
'! !

!CIHTMLPublisherTest methodsFor: 'accessing' stamp: 'ErwanDouaille 4/30/2013 15:58'!
publisherClass
	^ CIHTMLPublisher ! !

!CIHTMLPublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:29'!
testContents
	| file path directory |
	
	directory := FileSystem memory.
	file := (self publisherClass new) 
		outputDirectory: directory;
		publishValidationResult: (CIValidationResult change: (CITestChange new name: 'TestEntity')).
	path := file outputDirectory / 'TestEntity', 'html'.
	
	self assert: (directory exists: path ) description: 'Testing the creation of html file'.
	self assert: path readStream contents asString equals: self defaultContent.! !

!CIHTMLPublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:24'!
testEntity
	| file directory path |
	
	directory := FileSystem memory.
	file := (self publisherClass new) 
		outputDirectory: directory;
		publishValidationResult: (CIValidationResult change: (CITestChange new name: 'TestEntity')).
	path := file outputDirectory / 'TestEntity', 'html'.
	
	self assert: (directory exists: path ) description: 'Testing the creation of html file'.! !

CIPublisherTest subclass: #CIPluggablePublisherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIPluggablePublisherTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:16'!
publisherClass
	^ CIPluggablePublisher! !

!CIPluggablePublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:12'!
testNoBlocks
	" check that all publishing hooks work even without blocks"
	| publisher |
	publisher := CIPluggablePublisher new.
	
	publisher 
		publishBeforeValidation: #aValue;
		publishChangeNotFound: #aValue;
		publishIntermediateResult: #aValue;
		publishValidationResult: #aValue.! !

!CIPluggablePublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:30'!
testPublishBeforeValidation
	| publisher publishedSomethingElse publishedBeforeValidation |
	
	publishedSomethingElse := false.
	publishedBeforeValidation := false.
	publisher := CIPluggablePublisher block: [ publishedSomethingElse := true ].
	publisher beforeValidationBlock: [ publishedBeforeValidation := true ].
	
	publisher publishBeforeValidation: #anObject.
	self assert: publishedBeforeValidation  description: 'Ensure the validation'.
	self deny: publishedSomethingElse.! !

!CIPluggablePublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:31'!
testPublishChangeNotFound
	| publisher publishedSomethingElse publishedChangeNotFound |
	
	publishedSomethingElse := false.
	publishedChangeNotFound := false.
	publisher := CIPluggablePublisher block: [ publishedSomethingElse := true ].
	publisher changeNotFoundBlock: [ publishedChangeNotFound := true ].
	
	publisher publishChangeNotFound: #anObject.
	self assert: publishedChangeNotFound .
	self deny: publishedSomethingElse.! !

!CIPluggablePublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:10'!
testPublishIntermediateResult
	| publisher publishedSomethingElse published |
	
	publishedSomethingElse := false.
	published := false.
	publisher := CIPluggablePublisher block: [ publishedSomethingElse := true ].
	publisher intermediateResultBlock: [ published := true ].
	
	publisher publishIntermediateResult: #anObject.
	self assert: published.
	self deny: publishedSomethingElse.! !

!CIPluggablePublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:10'!
testPublishValidationResult
	| publisher publishedSomethingElse published |
	
	publishedSomethingElse := false.
	published := false.
	publisher := CIPluggablePublisher block: [ publishedSomethingElse := true ].
	publisher validationResultBlock: [ published := true ].
	
	publisher publishValidationResult: #anObject.
	self assert: published.
	self deny: publishedSomethingElse.! !

!CIPluggablePublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:15'!
testResetAllBlocks
	| publisher published |
	
	published := 0.
	publisher := CIPluggablePublisher new.
	
	publisher resetAllBlocks: [ published := published + 1 ].
	
	self assert: published = 0.
	publisher 	publishBeforeValidation: #aValue.
	self assert: published = 1.
	
	publisher publishChangeNotFound: #aValue.
	self assert: published = 2.
	
	publisher publishIntermediateResult: #aValue.
	self assert: published = 3.
	
	publisher publishValidationResult: #aValue.
	self assert: published = 4.! !

!CIPublisherTest class methodsFor: 'testing' stamp: 'CamilloBruni 4/25/2013 21:36'!
isAbstract
	^ self = CIPublisherTest! !

!CIPublisherTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:15'!
publisherClass
	^ self subclassResponsibility! !

!CIPublisherTest methodsFor: 'setup' stamp: 'CamilloBruni 4/25/2013 21:43'!
setUp
	super setUp.
	instance := self newPublisher! !

!CIPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:44'!
testPublishBeforeValidation
	instance publishBeforeValidation: self newChange! !

!CIPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:45'!
testPublishChangeNotFound
	instance publishChangeNotFound: self newChange! !

!CIPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:45'!
testPublishIntermediateResult
	instance publishIntermediateResult: self newValidationResult! !

!CIPublisherTest methodsFor: 'tests' stamp: 'CamilloBruni 4/25/2013 21:46'!
testPublishValidationResult
	instance publishValidationResult: self newValidationResult.
	instance publishValidationResult: self newFailingValidationResult.! !

!CIPublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:22'!
testSetManager
	| manager |
	
	self assert: instance manager isNil.
	
	manager := self newManager.
	instance manager: manager.
	self assert: instance manager equals: manager! !

CIPublisherTest subclass: #CIXMLPublisherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIXMLPublisherTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 13:58'!
defaultContent

	^ '<?xml version="1.0" encoding="UTF-8"?>
<!!--Pharo CI report-->
<report>
    <name>TestEntity - report</name>
    <finality>succeed</finality>
</report>'! !

!CIXMLPublisherTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 13:06'!
publisherClass
	^ CIXMLPublisher ! !

!CIXMLPublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:24'!
testContents
	| file path directory |
	
	directory := FileSystem memory.
	file := (self publisherClass new) 
		outputDirectory: directory;
		publishValidationResult: (CIValidationResult change: (CITestChange new name: 'TestEntity')).
	path := file outputDirectory / 'TestEntity', 'xml'.
	
	self assert: (directory exists: path ) description: 'Testing the creation of xml file'.
	self assert: path readStream contents asString equals: self defaultContent.! !

!CIXMLPublisherTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:23'!
testEntity
	| file directory path |
	
	directory := FileSystem memory.
	file := (self publisherClass new) 
		outputDirectory: directory;
		publishValidationResult: (CIValidationResult change: (CITestChange new name: 'TestEntity')).
	path := file outputDirectory / 'TestEntity', 'xml'.
	
	self assert: (directory exists: path ) description: 'Testing the creation of the xml file'.! !

!CITestCase class methodsFor: 'testing' stamp: 'CamilloBruni 4/29/2013 23:54'!
isAbstract
	^ self = CITestCase! !

!CITestCase methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 23:39'!
newChange
	^ CITestChange new! !

!CITestCase methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 14:15'!
newFailingValidationResult
	| result |
	result := self newValidationResult.
	result
		addError: 'failure 1';
		addError: 'failure 2';
		addError: 'failure 3'.
	^ result! !

!CITestCase methodsFor: 'accessing' stamp: 'ErwanDouaille 4/30/2013 17:38'!
newFailingValidationRule
	^ CITestRule block: [ :change| 
		self newFailingValidationResult ]! !

!CITestCase methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 23:39'!
newManager
	^ CIChangeManager new! !

!CITestCase methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 23:39'!
newPublisher
	^ self publisherClass new! !

!CITestCase methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:23'!
newValidationResult
	^ CIValidationResult new.! !

!CITestCase methodsFor: 'accessing' stamp: 'ErwanDouaille 4/30/2013 17:38'!
newValidationRule
	^ CITestRule block: [ :change| 
		self newValidationResult ]! !

CITestCase subclass: #CIValidationRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

CIValidationRuleTest subclass: #CIComposedRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

CIComposedRuleTest subclass: #CIAndRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIAndRuleTest methodsFor: 'accessing' stamp: 'CI Validation User 5/9/2013 00:26'!
ruleClass
	^ CIAndRule! !

!CIAndRuleTest methodsFor: 'tests' stamp: 'CI Validation User 5/11/2013 21:51'!
testFailureAndMessage

	| ruleOne ruleTwo aResult validatedRuleOne validatedRuleTwo |
	
	validatedRuleOne := false.
	validatedRuleTwo := false.
	
	ruleOne := [ :change |
		validatedRuleOne := true.
		CIValidationResult failure: 'test failure' ] asCIValidationRule.
	ruleTwo := [ :change | 
		validatedRuleTwo := true.
		CIValidationResult message: 'test message' ] asCIValidationRule.
	
	aResult := (ruleOne & ruleTwo) validate: self newChange.
	self assert: validatedRuleOne.
	self deny: validatedRuleTwo.
	
	"in case of the failure is handle first, it shouldn't continue to run tests, that's why we get 0 message and 1 failure"
	self assert: aResult errors size equals: 1.
	self assert: aResult messages size equals: 0.	
	self assert: aResult warnings size equals: 0.! !

!CIAndRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testMessageAndFailure

	| ruleOne ruleTwo aResult validatedRuleOne validatedRuleTwo |
	
	validatedRuleOne := false.
	validatedRuleTwo := false.
	
	ruleOne := [ :change |
		validatedRuleOne := true.
		CIValidationResult message: 'test message' ] asCIValidationRule.
	ruleTwo := [ :change | 
		validatedRuleTwo := true. 
		CIValidationResult failure: 'test failure'] asCIValidationRule.
	
	aResult := (ruleOne & ruleTwo) validate: self newChange.
	self assert: validatedRuleOne.
	self assert: validatedRuleTwo.
	
	"in case of the message is handle first, it should continue to run tests, that's why we get 1 message and 1 failure"
	self assert: aResult errors size equals: 1.
	self assert: aResult messages size equals: 1.	
	self assert: aResult warnings size equals: 0.! !

!CIComposedRuleTest class methodsFor: 'testing' stamp: 'CamilloBruni 4/30/2013 09:42'!
isAbstract
	^ self = CIComposedRuleTest! !

!CIComposedRuleTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 01:03'!
testLoadEmptyChange
	"Don't care about this test in ComposedRule"! !

!CIComposedRuleTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 01:03'!
testLoadFailingChange
	"Don't care about this test in ComposedRule"! !

!CIComposedRuleTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 01:03'!
testLoadSuccessfulChange
	"Don't care about this test in ComposedRule"! !

!CIComposedRuleTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 01:03'!
testLoadWarningChange
	"Don't care about this test in ComposedRule"! !

CIComposedRuleTest subclass: #CIListRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIListRuleTest methodsFor: 'accessing' stamp: 'CI Validation User 5/9/2013 00:26'!
ruleClass
	^ CIListRule! !

!CIListRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testShouldContinue

	| ruleOne ruleTwo aResult ruleThree ruleFour |
	
	ruleOne :=   [ :change | CIValidationResult failure: 'test failure' ] asCIValidationRule.
	ruleTwo :=   [ :change | CIValidationResult message: 'test message' ] asCIValidationRule.
	ruleThree := [ :change | CIValidationResult warning: 'test message' ] asCIValidationRule.
	ruleFour :=  [ :change | CIValidationResult failure: 'test message' ] asCIValidationRule.
	aResult := (ruleOne, ruleTwo, ruleThree, ruleFour) validate: self newChange.
	
	self assert: aResult errors size equals: 2.
	self assert: aResult messages size equals: 1.	
	self assert: aResult warnings size equals: 1.! !

CIComposedRuleTest subclass: #CIOrRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIOrRuleTest methodsFor: 'accessing' stamp: 'CI Validation User 5/9/2013 00:26'!
ruleClass
	^ CIOrRule! !

!CIOrRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testFailureOrMessage

	| ruleOne ruleTwo aResult validatedRuleOne validatedRuleTwo |
	
	validatedRuleOne := false.
	validatedRuleTwo := false.
	
	ruleOne := [ :change |
		validatedRuleOne := true.
		CIValidationResult failure: 'test failure'] asCIValidationRule.
	ruleTwo := [ :change | 
		validatedRuleTwo := true. 
		CIValidationResult message: 'test message' ] asCIValidationRule.
	
	aResult := (ruleOne | ruleTwo) validate: self newChange.
	self assert: validatedRuleOne.
	self assert: validatedRuleTwo.
	
	self assert: aResult errors size equals: 1.
	self assert: aResult messages size equals: 1.	
	self assert: aResult warnings size equals: 0.! !

!CIOrRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testMessageOrFailure

	| ruleOne ruleTwo aResult validatedRuleOne validatedRuleTwo |
	
	validatedRuleOne := false.
	validatedRuleTwo := false.
	
	ruleOne := [ :change |
		validatedRuleOne := true.
		CIValidationResult message: 'test message' ] asCIValidationRule.
	ruleTwo := [ :change | 
		validatedRuleTwo := true. 
		CIValidationResult failure: 'test failure'] asCIValidationRule.
	
	aResult := (ruleOne | ruleTwo) validate: self newChange.
	self assert: validatedRuleOne.
	self deny: validatedRuleTwo.
	
	self assert: aResult errors size equals: 0.
	self assert: aResult messages size equals: 1.	
	self assert: aResult warnings size equals: 0.! !

!CIOrRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testNothingOrFailure

	| ruleOne ruleTwo aResult validatedRuleOne validatedRuleTwo |
	
	validatedRuleOne := false.
	validatedRuleTwo := false.
	
	ruleOne := [ :change |
		validatedRuleOne := true.
		CIValidationResult new] asCIValidationRule.
	ruleTwo := [ :change | 
		validatedRuleTwo := true. 
		CIValidationResult message: 'test message' ] asCIValidationRule.
	
	aResult := (ruleOne | ruleTwo) validate: self newChange.
	self assert: validatedRuleOne.
	self deny: validatedRuleTwo.
	
	self assert: aResult errors size equals: 0.
	self assert: aResult messages size equals: 0.	
	self assert: aResult warnings size equals: 0.! !

CIValidationRuleTest subclass: #CIRuleModifierTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

CIRuleModifierTest subclass: #CIErrorToWarningModiferTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIErrorToWarningModiferTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/30/2013 00:02'!
ruleClass
	^ CIErrorToWarningModifer! !

!CIErrorToWarningModiferTest methodsFor: 'tests' stamp: 'CamilloBruni 5/11/2013 21:03'!
testHarden
	| rule hardenedRule result |
	
	rule := [ :change | CIValidationResult warning: 'warning' ] asCIValidationRule .
	hardenedRule := rule harden.
	
	result := hardenedRule validate: self newChange.
	
	self assert: result warnings isEmpty.
	self assert: result errors first equals: 'warning'.! !

!CIErrorToWarningModiferTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testModify
	| aResult aModifyResult |
	
	
	aResult := CIValidationResult new.
	aResult addError: 'a'.
	aResult addMessage: 'b'.
	aResult addWarning: 'c'.
	aModifyResult := CIErrorToWarningModifer new modifyResult: aResult.
	
	self assert: aResult errors size equals: 1.	
	self assert: aResult messages size equals: 1.	
	self assert: aResult warnings size equals: 1.	
	
	self assert: aModifyResult warnings size equals: 2.	
	self assert: aModifyResult messages size equals: 1.	
	self assert: aModifyResult errors size equals: 0.	
		
	self assert: (aModifyResult warnings first = 'a').
	self assert: (aModifyResult warnings second = 'c').
	self assert: (aModifyResult messages first = 'b').! !

!CIRuleModifierTest class methodsFor: 'testing' stamp: 'CamilloBruni 4/30/2013 00:01'!
isAbstract
	^ self = CIRuleModifierTest! !

!CIRuleModifierTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:23'!
newInstance
	^ self ruleClass 
		rule: self newValidationRule! !

!CIRuleModifierTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 00:18'!
testLoadFailingChange
	"invalid test for this rule"! !

!CIRuleModifierTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 00:18'!
testLoadSuccessfulChange
	"invalid test for this rule"! !

!CIRuleModifierTest methodsFor: 'tests' stamp: 'CI Validation User 5/9/2013 00:18'!
testLoadWarningChange
	"invalid test for this rule"! !

CIRuleModifierTest subclass: #CIWarningToErrorModiferTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIWarningToErrorModiferTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/30/2013 00:02'!
ruleClass
	^ CIWarningToErrorModifer! !

!CIWarningToErrorModiferTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testModify
	| aResult aModifyResult |
	
	
	aResult := CIValidationResult new.
	aResult addError: 'a'.
	aResult addMessage: 'b'.
	aResult addWarning: 'c'.
	aModifyResult := (CIWarningToErrorModifer new) modifyResult: aResult.
	
	self assert: aResult errors size equals: 1.	
	self assert: aResult messages size equals: 1.	
	self assert: aResult warnings size equals: 1.	
	
	self assert: aModifyResult errors size equals: 2.	
	self assert: aModifyResult messages size equals: 1.	
	self assert: aModifyResult warnings size equals: 0.	
		
	self assert: (aModifyResult errors first = 'a').
	self assert: (aModifyResult errors second = 'c').
	self assert: (aModifyResult messages first = 'b').! !

!CIWarningToErrorModiferTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:36'!
testSoften
	| aRule aSoftenedRule result |
	
	aRule := [ :change | CIValidationResult failure: 'failure' ] asCIValidationRule.
	aSoftenedRule := aRule soften.
	result := aSoftenedRule validate: self newChange.
	
	self deny: aRule validate isSuccess.
	self assert: result isSuccess description: 'Ensure tests is successful'.
	
	self assert: result errors isEmpty description: 'Ensure there is no errors for the validation'.
	self assert: result warnings size equals: 1.
	self assert: result warnings first equals: 'failure'.! !

CIValidationRuleTest subclass: #CIRunTestsRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIRunTestsRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 11:13'!
createNewTestClass
	^ TestCase subclass: (#CIRunTestsRule_, self selector) asSymbol
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: self defaultTestPackage.! !

!CIRunTestsRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 11:13'!
defaultTestPackage
	^ 'KernelTests-Numbers'! !

!CIRunTestsRuleTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/13/2013 11:30'!
newFailingChange
	^ [ | class |
		class := self createNewTestClass.
		class compile: 'testFail
			self fail'.
		class compile: 'testError
			Error signal: #anErrorDescription asWideString '.
		class compile: 'testError2
			self assert: false description: (Character value: 1000) asWideString ' ] asCIChange! !

!CIRunTestsRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 11:18'!
newInstance
	^ self ruleClass selectTestCaseBlock: [ :aClass | 
		aClass package name beginsWith: self defaultTestPackage ]! !

!CIRunTestsRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 10:51'!
newSuccessfulChange
	
	^ [ | class |
		class := self createNewTestClass.
		class compile: 'testSuccess
			self assert: true' ] asCIChange! !

!CIRunTestsRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 11:14'!
newWarningChange
	
	^ [ | class |
		class := self createNewTestClass.
		class compile: 'testSkip
			self skip: #skipping' ] asCIChange! !

!CIRunTestsRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 21:35'!
ruleClass
	^ CIRunTestsRule! !

!CIRunTestsRuleTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/16/2013 10:34'!
testErrorValidation
	| instance aResult |
	
	instance := self newInstance.
	aResult := instance validate: self newFailingChange. 
	
	self assert: aResult errors size > 0 description: 'Ensure there is errors'.! !

!CIRunTestsRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/9/2013 14:16'!
testPerfectValidation
	| instance aResult |
	
	instance := self newInstance.
	aResult := instance validate: self newSuccessfulChange.
	
	self assert: aResult errors size equals: 0.	
	self assert: aResult messages size equals: 0.	
	self assert: aResult warnings size equals: 0.	! !

CIValidationRuleTest subclass: #CISmallIntRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

CISmallIntRuleTest subclass: #CISmallIntRuleClassNoCommentTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CISmallIntRuleClassNoCommentTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:45'!
newFailingChange
	^ CITestChange loadBlock: [ Error signal ]! !

!CISmallIntRuleClassNoCommentTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:45'!
newSuccessfulChange
	^ CITestChange loadBlock: [ 
		Object subclass: #CITestClass	
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'CI-Test'.
	(Smalltalk at:#CITestClass) comment: ' testing !!' ]
	
	! !

!CISmallIntRuleClassNoCommentTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:45'!
newWarningChange
	^ CITestChange loadBlock: [ 
		Object subclass: #CITestClass	
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'CI-Test' ]
	
	! !

!CISmallIntRuleClassNoCommentTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:45'!
ruleClass
	^ RBNoClassCommentRule   ! !

!CISmallIntRuleTest class methodsFor: 'testing' stamp: 'ErwanDouaille 5/15/2013 13:47'!
isAbstract
	^ self = CISmallIntRuleTest! !

!CISmallIntRuleTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/14/2013 16:58'!
newInstance
	^ self ruleClass asCIValidationRule  ! !

CISmallIntRuleTest subclass: #CISmallIntRuleUncategorizedMethodTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CISmallIntRuleUncategorizedMethodTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:49'!
newFailingChange
	^ CITestChange loadBlock: [ Error signal ]! !

!CISmallIntRuleUncategorizedMethodTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:49'!
newSuccessfulChange
	^ CITestChange loadBlock: [ 
		Object subclass: #CITestClass	
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'CI-Test'.]! !

!CISmallIntRuleUncategorizedMethodTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 13:49'!
newWarningChange
	^ CITestChange loadBlock: [ 
		Object subclass: #CITestClass	
			instanceVariableNames: ''
			classVariableNames: ''
			poolDictionaries: ''
			category: 'CI-Test'.
		 (Smalltalk at:#CITestClass) compile: 'testingUngategorized
^ self']
	
	! !

!CISmallIntRuleUncategorizedMethodTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/15/2013 14:46'!
ruleClass
	^ RBUnclassifiedMethodsRule ! !

CIValidationRuleTest subclass: #CITestRuleTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CITestRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:09'!
newFailingChange
	^ CITestChange loadBlock: [ CIValidationResult failure: 'failure' ]! !

!CITestRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:12'!
newInstance
	^ self ruleClass block: [ :change | 
		change loadBlock 
			ifNotNil: [ :block | block value ]
			ifNil: [ CIValidationResult new ]]! !

!CITestRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:09'!
newSuccessfulChange
	^ CITestChange loadBlock: [ CIValidationResult new ]! !

!CITestRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:09'!
newWarningChange
	^ CITestChange loadBlock: [ CIValidationResult warning: 'warning' ]! !

!CITestRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 5/11/2013 21:08'!
ruleClass
	^ CITestRule! !

!CIValidationRuleTest class methodsFor: 'testing' stamp: 'CamilloBruni 4/29/2013 21:34'!
isAbstract
	^ self = CIValidationRuleTest! !

!CIValidationRuleTest methodsFor: 'accessing' stamp: 'ErwanDouaille 4/30/2013 17:14'!
newFailingChange
	^ self shouldBeImplemented! !

!CIValidationRuleTest methodsFor: 'accessing' stamp: 'ErwanDouaille 5/14/2013 16:58'!
newInstance
	^ self ruleClass new! !

!CIValidationRuleTest methodsFor: 'accessing' stamp: 'ErwanDouaille 4/30/2013 17:15'!
newSuccessfulChange
	^ self shouldBeImplemented! !

!CIValidationRuleTest methodsFor: 'accessing' stamp: 'ErwanDouaille 4/30/2013 17:32'!
newWarningChange
	^ self subclassresponsibility ! !

!CIValidationRuleTest methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 21:35'!
ruleClass
	self subclassResponsibility! !

!CIValidationRuleTest methodsFor: 'tests' stamp: 'ErwanDouaille 4/30/2013 17:13'!
testLoadEmptyChange
	| rule result |
	rule := self newInstance.
	result := rule validate: self newChange.
	self assert: result isSuccess.! !

!CIValidationRuleTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/13/2013 15:51'!
testLoadFailingChange
	| rule result |
	rule := self newInstance.
	result := rule validate: self newFailingChange.
	self assert: result isFailure.! !

!CIValidationRuleTest methodsFor: 'tests' stamp: 'CamilloBruni 5/14/2013 13:21'!
testLoadNil

	self should: [ self newInstance validate: nil ] raise: Error, AssertionFailure.
	self should: [ self newInstance validate ] raise: Error, AssertionFailure.! !

!CIValidationRuleTest methodsFor: 'tests' stamp: 'ErwanDouaille 4/30/2013 17:34'!
testLoadSuccessfulChange
	| rule result |
	rule := self newInstance.
	result := rule validate: self newSuccessfulChange.
	self assert: result isSuccess.! !

!CIValidationRuleTest methodsFor: 'tests' stamp: 'ErwanDouaille 5/2/2013 18:17'!
testLoadWarningChange
	| rule result |
	rule := self newInstance.
	result := rule validate: self newWarningChange.
	self assert: result isSuccess.
	self assert: result hasWarnings.! !

!CIValidationRuleTest methodsFor: 'helper' stamp: 'CamilloBruni 4/30/2013 00:09'!
validate: rule
	^ rule validate: self newChange! !

Object subclass: #CIAbstractChange
	instanceVariableNames: 'source'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIAbstractChange commentStamp: '<historical>' prior: 0!
I am an abstract representation of an issue tracker case mainly used to define protocol methods!

!CIAbstractChange class methodsFor: 'instance creation' stamp: 'ErwanDouaille 4/11/2013 15:34'!
source: aCISource 
	^ self new source: aCISource; yourself! !

!CIAbstractChange methodsFor: 'conversion' stamp: 'CI Validation User 5/8/2013 13:39'!
asCIChange
	^ self! !

!CIAbstractChange methodsFor: 'asserting' stamp: 'CamilloBruni 4/14/2013 22:43'!
assertLoadable
	self isLoadable
		ifFalse: [ ChangeNotFound signalChange: self ]! !

!CIAbstractChange methodsFor: 'protocol' stamp: 'CamilloBruni 4/14/2013 22:44'!
basicLoad
	self subclassResponsibility! !

!CIAbstractChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 16:24'!
id
	self subclassResponsibility .! !

!CIAbstractChange methodsFor: 'testing' stamp: 'CamilloBruni 4/14/2013 22:25'!
isLoadable
	"return true if this change as loadable sources attached"
	^ self subclassResponsibility! !

!CIAbstractChange methodsFor: 'loading' stamp: 'CamilloBruni 5/14/2013 14:29'!
load
	| result |
	self assertLoadable.
	result := self basicLoad.
	Smalltalk garbageCollect.
	^ result! !

!CIAbstractChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:42'!
manager
	^ self source manager! !

!CIAbstractChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 23:25'!
name
	^ self subclassResponsibility! !

!CIAbstractChange methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 3/22/2013 18:36'!
publicUrl

	self subclassResponsibility! !

!CIAbstractChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 16:21'!
source
	^ source! !

!CIAbstractChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 16:21'!
source: anObject
	source := anObject! !

CIAbstractChange subclass: #CIConfigurationChange
	instanceVariableNames: 'impactedPackages configurationPoint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIConfigurationChange commentStamp: '<historical>' prior: 0!
I am an abstract representation for a configuration.
Loading this change will the load the code associated with an attached configuration.!

!CIConfigurationChange class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/26/2013 16:24'!
source: aCISource configurationPoint: aMetacelloVersion
	^ (self source: aCISource) 
		configurationPoint: aMetacelloVersion;
		yourself.! !

!CIConfigurationChange methodsFor: 'protocol' stamp: 'ErwanDouaille 5/6/2013 15:26'!
basicLoad

	"should look if empty string works"
	(self group isNil )
		ifTrue: [ self configurationPoint  load ]
		ifFalse: [ self configurationPoint load: self group] .
	self impactedPackages: self resolveImpactedPackages.! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:22'!
configurationPoint
	^ configurationPoint! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:23'!
configurationPoint: aMetacelloVersion
	configurationPoint := aMetacelloVersion! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'ErwanDouaille 5/6/2013 17:46'!
group
	^ self source group! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'ErwanDouaille 5/6/2013 13:31'!
id
	^self configurationPoint name! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/17/2013 11:21'!
impactedPackages
	^ impactedPackages! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/17/2013 11:21'!
impactedPackages: anObject
	impactedPackages := anObject! !

!CIConfigurationChange methodsFor: 'testing' stamp: 'CamilloBruni 4/26/2013 16:22'!
isLoadable
	^ configurationPoint notNil! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'ErwanDouaille 5/6/2013 15:53'!
name

	^ self configurationPoint spec projectLabel ! !

!CIConfigurationChange methodsFor: 'protocol' stamp: 'CamilloBruni 4/26/2013 15:49'!
publicUrl
	^ self source url! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/17/2013 14:47'!
resolveImpactedPackages
	| aSet |
	aSet := OrderedCollection new.
	RPackage organizer packageNames do: [ :packageName|
		((self name,'-.*') asRegex matches: packageName)
			ifTrue: [ aSet add: packageName ]].
	^ aSet
	! !

!CIConfigurationChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:15'!
version
	"which version of the configuration are we using"
	self shouldBeImplemented! !

CIAbstractChange subclass: #CIEnvironmentChange
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIEnvironmentChange commentStamp: '<historical>' prior: 0!
blabal!

!CIEnvironmentChange class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 4/29/2013 20:34'!
from: oldEnviroment to: newEnvironment
	^ self new
		from: oldEnviroment;
		to: newEnvironment;
		yourself! !

!CIEnvironmentChange methodsFor: 'accessing package changes' stamp: 'CamilloBruni 4/29/2013 20:39'!
addedPackages
	^ self from packages \ self to packages! !

!CIEnvironmentChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 20:34'!
from
	^ from! !

!CIEnvironmentChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 20:34'!
from: anObject
	from := anObject! !

!CIEnvironmentChange methodsFor: 'accessing package changes' stamp: 'CamilloBruni 4/29/2013 20:38'!
modifiedPackages
	| packages |
	
	packages := Set new.
	self modifiedClasses do: [ :clazz |
		packages add: clazz package ].
	^ packages! !

!CIEnvironmentChange methodsFor: 'accessing package changes' stamp: 'CamilloBruni 4/29/2013 20:39'!
removedPackages
	^ self to packages \ self from packages! !

!CIEnvironmentChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 20:34'!
to
	^ to! !

!CIEnvironmentChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 20:34'!
to: anObject
	to := anObject! !

CIAbstractChange subclass: #CISliceChange
	instanceVariableNames: 'case slice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CISliceChange commentStamp: '<historical>' prior: 0!
I am a representation of an issue tracker case mainly used to define protocol methods!

!CISliceChange class methodsFor: 'instance creation' stamp: 'ErwanDouaille 4/11/2013 15:33'!
source: aCISource case: aTrackerCase
	^ (self source: aCISource)  case: aTrackerCase;yourself ! !

!CISliceChange methodsFor: 'protocol' stamp: 'CamilloBruni 5/14/2013 13:41'!
basicLoad	
	[[ self slice merge ] 
		on: MCMergeResolutionRequest do: [ :request |
			Error signal: 'Merge conflict occured while loading slice'  ]]
		on: Warning do: [ :warning |
			Error signal: 'Warning occurred while loading slice: ', warning asString ]! !

!CISliceChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 15:26'!
case
	^ case! !

!CISliceChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 15:26'!
case: anObject
	case := anObject! !

!CISliceChange methodsFor: 'updating' stamp: 'CamilloBruni 4/15/2013 20:01'!
fixReviewed: aMessage in: pharoReleaseNumber
	self case 
		statusFixReviewed; 
		saveStatus: aMessage withInternetLineEndings.
	
	self case 
		tags add: 'Validated in ', pharoReleaseNumber asString.
	self case	saveTags! !

!CISliceChange methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 16:24'!
id 
	 ^ case id! !

!CISliceChange methodsFor: 'testing' stamp: 'CamilloBruni 4/14/2013 22:25'!
isLoadable
	^ self slice isNotNil! !

!CISliceChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 22:47'!
loadSlice
	^ slice := self source sliceFor: self case! !

!CISliceChange methodsFor: 'updating' stamp: 'CamilloBruni 4/15/2013 10:17'!
lockForValidation
	^ self case 
		statusMonkeyIsChecking; 
		saveStatus! !

!CISliceChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 23:25'!
name
	^ self case title! !

!CISliceChange methodsFor: 'printing' stamp: 'CamilloBruni 5/1/2013 11:41'!
printOn: aStream
	aStream nextPutAll: 'SLICE '; print: self id; space.
	aStream nextPutAll: self slice url ! !

!CISliceChange methodsFor: 'protocol' stamp: 'ErwanDouaille 4/11/2013 15:28'!
publicUrl
	^ self case publicUrl ! !

!CISliceChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 22:36'!
slice
	^ slice ifNil: [ self loadSlice ]! !

!CISliceChange methodsFor: 'updating' stamp: 'CamilloBruni 4/15/2013 14:21'!
workNeeded: aMessage
	^ self case 
		statusWorkNeeded; 
		saveStatus: aMessage! !

!CISliceChange methodsFor: 'updating' stamp: 'CamilloBruni 4/15/2013 14:18'!
workNeededFailingTests: message
	^ self case 
		statusWorkNeededFailingTests; 
		saveStatus: message! !

!CISliceChange methodsFor: 'updating' stamp: 'CamilloBruni 4/15/2013 10:16'!
workNeededNoSources
	^ self case 
		statusWorkNeededNoSources; 
		saveStatus! !

CIAbstractChange subclass: #CITestChange
	instanceVariableNames: 'id isLoadable loadBlock name publicUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CITestChange commentStamp: '<historical>' prior: 0!
I am a change object used for testing purposes.
All my properties can be set from the outside.!

!CITestChange class methodsFor: 'instance creation' stamp: 'ErwanDouaille 4/30/2013 17:22'!
loadBlock: aBlock

	^ self new
		loadBlock: aBlock;
		yourself.! !

!CITestChange methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 21:11'!
basicLoad
	^ self loadBlock ifNotNil: [ self loadBlock value ]! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:50'!
id
	^ id! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:49'!
id: anObject
	id := anObject! !

!CITestChange methodsFor: 'initialize' stamp: 'CamilloBruni 4/29/2013 23:49'!
initialize

	isLoadable := true.! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 23:50'!
isLoadable
	^ isLoadable! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 23:50'!
isLoadable: aBoolean
	isLoadable := aBoolean! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:49'!
loadBlock
	^ loadBlock! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 23:50'!
loadBlock: aBlock
	loadBlock := aBlock! !

!CITestChange methodsFor: 'accessing' stamp: 'CI Validation User 5/8/2013 14:18'!
name
	^ name ifNil: [ 'TestChange:', self loadBlock asString ]! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:49'!
name: anObject
	name := anObject! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:50'!
publicUrl
	^ publicUrl! !

!CITestChange methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:49'!
publicUrl: anObject
	publicUrl := anObject! !

Object subclass: #CIAbstractPublisher
	instanceVariableNames: 'manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIAbstractPublisher commentStamp: '<historical>' prior: 0!
I am an abstract result / change publisher for the CI system.
I will be informed
- before the validator checks a change
- after the validation was performed
!

!CIAbstractPublisher class methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 14:13'!
, anotherPublisher
	^ self asCIPublisher , anotherPublisher! !

!CIAbstractPublisher class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/25/2013 14:12'!
asCIPublisher
	^ self new! !

!CIAbstractPublisher class methodsFor: 'instance creation' stamp: 'ErwanDouaille 4/24/2013 10:46'!
manager: aCIPharoManager
	^ self new 
		manager:  aCIPharoManager;
		yourself.! !

!CIAbstractPublisher methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 14:10'!
, anotherPubliser
	^ anotherPubliser asCIPublisher addWith: self ! !

!CIAbstractPublisher methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 14:11'!
addWith: anotherRule
	^ CIComposedPublisher 
		with: anotherRule 
		with: self! !

!CIAbstractPublisher methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 14:00'!
addWithAll: anotherRule
	^ anotherRule add: self! !

!CIAbstractPublisher methodsFor: 'conversion' stamp: 'CamilloBruni 4/25/2013 14:10'!
asCIPublisher
	^ self! !

!CIAbstractPublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:44'!
manager
	^ manager! !

!CIAbstractPublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:44'!
manager: anObject
	manager := anObject! !

!CIAbstractPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/14/2013 21:46'!
publishBeforeValidation: aCIChange
	"Publish a CIChange that is about to be validatet"
	self subclassResponsibility! !

!CIAbstractPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/14/2013 22:39'!
publishChangeNotFound: aCIChange
	"Triggered if the change is not found or has no loadable sources attached"
	self subclassResponsibility! !

!CIAbstractPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:34'!
publishFailure: aCIValidationResult
	"pbulish a failing validation result"
	self subclassResponsibility! !

!CIAbstractPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 21:02'!
publishIntermediateResult: aValidationResult
	"By default nothing to be done"! !

!CIAbstractPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:34'!
publishSuccess: aCIValidationResult
	"pbulish a sucessful validation result"
	self subclassResponsibility! !

!CIAbstractPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:31'!
publishValidationResult: aCIValidationResult
	"Publish the result of validation"
	
	aCIValidationResult	isSuccess 
			ifTrue: [ self publishSuccess: aCIValidationResult ]
			ifFalse: [ self publishFailure: aCIValidationResult ].! !

!CIAbstractPublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:51'!
source
	^ self manager source! !

CIAbstractPublisher subclass: #CICommandLinePublisher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CICommandLinePublisher commentStamp: '<historical>' prior: 0!
A CICommandLinePublisher is a publisher which publish on the shell directlty.!

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/29/2013 00:49'!
publishBeforeValidation: aCIChange
	VTermOutputDriver stderr 
		yellow: 'Starting validation of ', aCIChange asString; 
		flush; clear; lf.! !

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:28'!
publishChangeNotFound: aChange
	VTermOutputDriver stderr 
		color256: Color orange; 
		<< aChange name asString; << ' >> no changes has been found'; 
		flush; clear; lf.! !

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 5/9/2013 14:16'!
publishFailure: aCIValidationResult 

	VTermOutputDriver stderr 
		red: (aCIValidationResult change name asString, ' >> test failure report').
	
	aCIValidationResult errors do: [ :aFailure |
		VTermOutputDriver stderr red: aFailure asString;lf ]! !

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/29/2013 15:28'!
publishMessages: aCIValidationResult 

	VTermOutputDriver stderr 
		color256: Color orange; 
		<<(aCIValidationResult change name asString, ' >> test success report') asString; 
		flush; clear; lf.
		
	aCIValidationResult messages do: [ :aMessage |
		VTermOutputDriver stderr color256: Color orange; <<aMessage asString; flush; clear; lf.]! !

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/29/2013 15:27'!
publishSuccess: aCIValidationResult 

	VTermOutputDriver stderr 
		green: (aCIValidationResult change name asString, ' >> test success report'); lf.
	self publishWarnings: aCIValidationResult .! !

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 5/9/2013 14:16'!
publishValidationResult: aCIValidationResult
	
	aCIValidationResult	isSuccess 
			ifTrue: [ self publishSuccess: aCIValidationResult ]
			ifFalse: [ self publishFailure: aCIValidationResult ].
	(aCIValidationResult messages isNil or: [ aCIValidationResult errors isEmpty ])
		ifFalse: [ self publishMessages: aCIValidationResult ].! !

!CICommandLinePublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 4/24/2013 13:07'!
publishWarnings: aCIValidationResult 

	VTermOutputDriver stderr color256: Color orange; <<(aCIValidationResult change name asString, ' >> warning report :') asString; flush; clear; lf.
	aCIValidationResult warnings do: [ :aWarnings |
		VTermOutputDriver stderr color256: Color orange; <<aWarnings asString; flush; clear; lf.]! !

CIAbstractPublisher subclass: #CIComposedPublisher
	instanceVariableNames: 'publishers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIComposedPublisher commentStamp: '<historical>' prior: 0!
I display validation result and progress on mutliple other publishers.
This is useful for instance if you want to have direct feedback on the command line using the CICommandLinePublisher and at the same time use another publisher.!

!CIComposedPublisher class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/25/2013 14:14'!
with: aPublisher with: anotherPublisher
	^ self new
		add: aPublisher;
		add: anotherPublisher;
		yourself! !

!CIComposedPublisher methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 20:17'!
, anotherRule
	^ anotherRule asCIPublisher addWithAll: self! !

!CIComposedPublisher methodsFor: 'adding' stamp: 'CamilloBruni 4/24/2013 22:30'!
add: aCIPublisher
	self publishers add: aCIPublisher .! !

!CIComposedPublisher methodsFor: 'adding' stamp: 'CamilloBruni 4/25/2013 20:14'!
addAll: aCollection
	self publishers addAll: aCollection.! !

!CIComposedPublisher methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 14:01'!
addWith: anotherRule
	^ self add: anotherRule! !

!CIComposedPublisher methodsFor: 'concatenation' stamp: 'CamilloBruni 4/25/2013 20:14'!
addWithAll: anotherRule
	^ anotherRule addAll: self publishers! !

!CIComposedPublisher methodsFor: 'initialize-release' stamp: 'ErwanDouaille 4/24/2013 15:01'!
initialize 
	self publishers: OrderedCollection new.! !

!CIComposedPublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 14:09'!
manager: aCIChangeManager
	super manager: aCIChangeManager.
	self publishers do: [ :publisher |
		publisher manager: aCIChangeManager ]! !

!CIComposedPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:28'!
publishBeforeValidation: aCIChange
	
	self publishers do: [ :publisher | 
			publisher publishBeforeValidation: aCIChange ].! !

!CIComposedPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:30'!
publishChangeNotFound: aCIValidationResult
	
	self publishers do: [ :publisher | 
			publisher publishChangeNotFound: aCIValidationResult ].
	! !

!CIComposedPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 21:02'!
publishIntermediateResult: aCIValidationResult
	
	self publishers do: [ :publisher | 
			publisher publishIntermediateResult: aCIValidationResult ].
	! !

!CIComposedPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:28'!
publishValidationResult: aCIValidationResult
	
	self publishers do: [ :publisher | 
			publisher publishValidationResult: aCIValidationResult ].
	! !

!CIComposedPublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/24/2013 14:38'!
publishers
	^ publishers! !

!CIComposedPublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/24/2013 14:38'!
publishers: anObject
	publishers := anObject! !

CIAbstractPublisher subclass: #CIFilePublisher
	instanceVariableNames: 'outputDirectory stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIFilePublisher commentStamp: '<historical>' prior: 0!
I am an abstract publisher for file-based output formats.!

!CIFilePublisher methodsFor: 'initialize-release' stamp: 'ErwanDouaille 4/22/2013 15:41'!
initialize
	super initialize.
	self outputDirectory: FileSystem disk workingDirectory.! !

!CIFilePublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/22/2013 15:39'!
outputDirectory
	^ outputDirectory! !

!CIFilePublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/22/2013 15:39'!
outputDirectory: anObject
	outputDirectory := anObject! !

!CIFilePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:35'!
publishBeforeValidation: aCIChange
	"ingnored"! !

!CIFilePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/24/2013 22:35'!
publishChangeNotFound: aCIChange
	"ingnored"! !

!CIFilePublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/22/2013 15:39'!
stream
	^ stream! !

!CIFilePublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/22/2013 15:39'!
stream: anObject
	stream := anObject! !

CIFilePublisher subclass: #CIFuelPublisher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIFuelPublisher commentStamp: '<historical>' prior: 0!
I output validation result as fuel-serialized files.!

!CIFuelPublisher methodsFor: 'file creation' stamp: 'CamilloBruni 4/24/2013 22:38'!
publishValidationResult: aCIValidationResult
	FileStream forceNewFileNamed: aCIValidationResult change name asString, '.fuel' do: [:aStream |
		FLSerializer newDefault 
			showProgress;
			serialize: aCIValidationResult 
			on: aStream binary ].
	! !

CIFilePublisher subclass: #CIHTMLPublisher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIHTMLPublisher commentStamp: '<historical>' prior: 0!
A CIHTMLPublisher publish report as a html file!

!CIHTMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:20'!
htmlBeginning: aCIValidationResult
	self stream nextPutAll:  '<?xml version="1.0" encoding="UTF-8"?>
<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>', aCIValidationResult change name asString, ' -- Test report</title>
</head>
<body>'
! !

!CIHTMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:19'!
htmlEnding: aCIValidationResult
	self stream nextPutAll: '
</body>
</html>
'! !

!CIHTMLPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 5/9/2013 14:16'!
publishFailures: aCIValidationResult
	| aString |
	aString := '<h1>', aCIValidationResult change name asString, ' failures : </h1><ul>'.
	aCIValidationResult errors do: [ :aFailure |
		aString := aString, '<li>', aFailure asString, '</li>'. ].
	self stream nextPutAll:  aString, '</ul>'.
	! !

!CIHTMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:20'!
publishMessages: aCIValidationResult 
	| aString |
	aString := '<h1>', aCIValidationResult change name asString, ' messages : </h1><ul>'.
	aCIValidationResult messages do: [ :aMessage |
		aString := aString, '<li>', aMessage asString, '</li>'. ].
	self stream nextPutAll: aString, '</ul>'.
	! !

!CIHTMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:19'!
publishSuccess: aCIValidationResult

	self stream nextPutAll: '<h1>', aCIValidationResult change name asString, ' test succeed !! </h1>'.! !

!CIHTMLPublisher methodsFor: 'file creation' stamp: 'ErwanDouaille 5/7/2013 13:45'!
publishValidationResult: aCIValidationResult

	self stream: (self outputDirectory / aCIValidationResult change name asString, 'html') writeStream.
	self htmlBeginning: aCIValidationResult.
	
	(aCIValidationResult isSuccess )
			ifTrue: [self publishSuccess: aCIValidationResult]
			ifFalse: [ self publishFailures: aCIValidationResult].
	
	(aCIValidationResult warnings isNil or: aCIValidationResult warnings isEmpty ) 
		ifFalse: [self publishWarnings: aCIValidationResult]	.
	(aCIValidationResult messages isNil or: [ aCIValidationResult messages isEmpty ])
		ifFalse: [ self publishMessages: aCIValidationResult ].
		
	self htmlEnding: aCIValidationResult.
	self stream close.! !

!CIHTMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:20'!
publishWarnings: aCIValidationResult 
	| aString |
	aString := '<h1>', aCIValidationResult change name asString, ' warnings : </h1><ul>'.
	aCIValidationResult warnings do: [ :aWarning |
		aString := aString, '<li>', aWarning asString, '</li>'. ].
	self stream nextPutAll:  aString, '</ul>'.
	! !

CIFilePublisher subclass: #CIXMLPublisher
	instanceVariableNames: 'xmlWriter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIXMLPublisher commentStamp: '<historical>' prior: 0!
A CIXMLPublisher publish report as a xml file!

!CIXMLPublisher methodsFor: 'as yet unclassified' stamp: 'ErwanDouaille 5/7/2013 13:11'!
initialize 
	super initialize.
	self xmlWriter: XMLWriter new.! !

!CIXMLPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 5/9/2013 14:16'!
publishFailures: aCIValidationResult
	self xmlWriter
		writeWith: [ :writer | 
			writer tag: 'finality' with: 'succeed'.
			writer tag: 'failure' with: [ aCIValidationResult errors do: [ :aMessage | writer tag: 'result' with: aMessage ] ] ]! !

!CIXMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:45'!
publishMessages: aCIValidationResult
	self xmlWriter
		writeWith: [ :writer | writer tag: 'message' with: [ aCIValidationResult messages do: [ :aMessage | writer tag: 'result' with: aMessage ] ] ]! !

!CIXMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 11:27'!
publishSuccess: aCIValidationResult

	^self xmlWriter writeWith: [ :writer | writer tag: 'finality' with: 'succeed'].! !

!CIXMLPublisher methodsFor: 'file creation' stamp: 'CI Validation User 5/8/2013 15:44'!
publishValidationResult: aCIValidationResult
	| file |
	file := self outputDirectory / aCIValidationResult change name asString , 'xml'.
	file ensureDeleted.
	self stream: file writeStream.
	self xmlWriter stream: self stream.
	self xmlBeginning: aCIValidationResult.
	self xmlWriter
		writeWith: [ :writer | 
			writer
				tag: 'report'
				with: [ 
					writer tag: 'name' with: aCIValidationResult change name, ' - report'.
					aCIValidationResult isSuccess
						ifTrue: [ self publishSuccess: aCIValidationResult ]
						ifFalse: [ self publishFailures: aCIValidationResult ].
					(aCIValidationResult warnings isNil or: aCIValidationResult warnings isEmpty)
						ifFalse: [ self publishWarnings: aCIValidationResult ].
					(aCIValidationResult messages isNil or: [ aCIValidationResult messages isEmpty ])
						ifFalse: [ self publishMessages: aCIValidationResult ] ] ].
	self xmlWriter close! !

!CIXMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 11:17'!
publishWarnings: aCIValidationResult 
	
	self xmlWriter writeWith: [ :writer |
		writer tag: 'warnings' with: [
			aCIValidationResult warnings do: [ :aMessage |
				writer tag: 'result' with:  aMessage ]]].
	! !

!CIXMLPublisher methodsFor: 'publishing' stamp: 'ErwanDouaille 5/7/2013 13:53'!
xmlBeginning: aCIValidationResult
	self xmlWriter writeWith: [  :writer |
		writer 
			enablePrettyPrinting ;
			xml;
			comment: 'Pharo CI report']
! !

!CIXMLPublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 11:02'!
xmlWriter
	^ xmlWriter! !

!CIXMLPublisher methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 11:02'!
xmlWriter: anObject
	xmlWriter := anObject! !

CIAbstractPublisher subclass: #CIIssueTrackerPublisher
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIIssueTrackerPublisher commentStamp: '<historical>' prior: 0!
I publish change results on an issue tracker!

!CIIssueTrackerPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/15/2013 10:31'!
publishBeforeValidation: aCIChange
	"lock the issue"
	aCIChange lockForValidation! !

!CIIssueTrackerPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/14/2013 22:55'!
publishChangeNotFound: aChange
	aChange workNeededNoSources! !

!CIIssueTrackerPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 5/9/2013 14:16'!
publishFailure: aCIValidationResult 
	| hasTestFailures change |
	
	change := aCIValidationResult change.
	
	self flag: 'stupid test for now'.
	hasTestFailures := aCIValidationResult errors anySatisfy: [ :failure | 
		failure asString includesSubstring: '>>#test' ].
	
	hasTestFailures
		ifTrue: [ change workNeededFailingTests: aCIValidationResult asString ]
		ifFalse: [ change workNeeded: aCIValidationResult asString ]! !

!CIIssueTrackerPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/15/2013 19:52'!
publishSuccess: aCIValidationResult 
	| change |
	
	change := aCIValidationResult change.
	
	change 
		fixReviewed: aCIValidationResult asString 
		in: SystemVersion current highestUpdate! !

!CIIssueTrackerPublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/29/2013 15:29'!
publishValidationResult: aCIValidationResult

	aCIValidationResult	isSuccess 
		ifTrue: [ self publishSuccess: aCIValidationResult ]
		ifFalse: [ self publishFailure: aCIValidationResult ]! !

CIAbstractPublisher subclass: #CIPluggablePublisher
	instanceVariableNames: 'beforeValidationBlock changeNotFoundBlock validationResultBlock intermediateResultBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Publishing'!

!CIPluggablePublisher commentStamp: '<historical>' prior: 0!
I am a pluggable publisher that delegates all the publishing actions to blocks.
This is mainly useful for testing.!

!CIPluggablePublisher class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/25/2013 21:04'!
block: aBlock
	" create an instance using the same block for all actions."
	^ self new
		resetAllBlocks: aBlock;
		yourself! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
beforeValidationBlock
	^ beforeValidationBlock! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
beforeValidationBlock: anObject
	beforeValidationBlock := anObject! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
changeNotFoundBlock
	^ changeNotFoundBlock! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
changeNotFoundBlock: anObject
	changeNotFoundBlock := anObject! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
intermediateResultBlock
	^ intermediateResultBlock! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
intermediateResultBlock: anObject
	intermediateResultBlock := anObject! !

!CIPluggablePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 20:39'!
publishBeforeValidation: aCIChange
	self beforeValidationBlock ifNotNil: [ 
		self beforeValidationBlock cull: aCIChange ]! !

!CIPluggablePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 20:41'!
publishChangeNotFound: aCIChange
	self changeNotFoundBlock ifNotNil: [ 
		self changeNotFoundBlock cull: aCIChange ]! !

!CIPluggablePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 21:02'!
publishIntermediateResult: aCIValidationResult
	self intermediateResultBlock ifNotNil: [ 
		self intermediateResultBlock cull: aCIValidationResult ]! !

!CIPluggablePublisher methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 20:41'!
publishValidationResult: aCIValidationResult
	self validationResultBlock ifNotNil: [ 
		self validationResultBlock cull: aCIValidationResult ]! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 21:05'!
resetAllBlocks: aBlock
	"set all blocks to the given one"
	self
		beforeValidationBlock: aBlock;
		changeNotFoundBlock: aBlock;
		intermediateResultBlock: aBlock;
		validationResultBlock: aBlock! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
validationResultBlock
	^ validationResultBlock! !

!CIPluggablePublisher methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 20:26'!
validationResultBlock: anObject
	validationResultBlock := anObject! !

Object subclass: #CIAbstractSource
	instanceVariableNames: 'manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIAbstractSource commentStamp: '<historical>' prior: 0!
A CIAbstractIssueSource is an API than you have to use with an issue source.
The IssueChecker communicates with an issue source to get sources that can be loaded or validated.!

CIAbstractSource subclass: #CIAbstractMonticelloSource
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIAbstractMonticelloSource commentStamp: '<historical>' prior: 0!
I am an abstract change source with a minimal interface for a gofer and monticello.!

!CIAbstractMonticelloSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 15:40'!
gofer
	^ Gofer new 
		url: self url;
		yourself! !

!CIAbstractMonticelloSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 15:40'!
url
	^ url! !

!CIAbstractMonticelloSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 15:40'!
url: aUrl
	url := aUrl! !

CIAbstractMonticelloSource subclass: #CIConfigurationSource
	instanceVariableNames: 'metacelloProject group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIConfigurationSource commentStamp: '<historical>' prior: 0!
I am specialized issue source that loads configurations from a monticello repository.!

!CIConfigurationSource class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/26/2013 16:30'!
url: anURL 
	^ self basicNew 
		initializeWithUrl: anURL! !

!CIConfigurationSource class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/26/2013 16:30'!
url: anURL configurationName: aConfigurationName
	^ self basicNew 
		initializeWithUrl: anURL
		configurationName: aConfigurationName! !

!CIConfigurationSource methodsFor: 'protocol' stamp: 'CamilloBruni 4/26/2013 16:22'!
changeWithId: aVersionName
	"Returns a CIConfigurationChange for the given version using the default group.
	aVersion might be a numeric version such as: '1.0', '1.1' or as well a symbolic version name such as: #stable, #development, #last"
	^ CIConfigurationChange 
		source: self 
		configurationPoint: (self metacelloProject version: aVersionName)! !

!CIConfigurationSource methodsFor: 'protocol' stamp: 'CamilloBruni 4/26/2013 16:20'!
changeWithId: aVersion group: aGroupName
	"Returns a CIConfigurationChange for the given version and group.
	aVersion might be a numeric version such as: '1.0', '1.1' or as well a symbolic version name such as: #stable, #development, #last"
		self shouldBeImplemented! !

!CIConfigurationSource methodsFor: 'protocol' stamp: 'CamilloBruni 4/26/2013 16:26'!
changes
	"return all possible changes for this configuration. 
	For the configuration we only show the different top-level versions.
	Groups are handled separetly."! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'ErwanDouaille 5/6/2013 16:00'!
group
	^ group! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'ErwanDouaille 5/6/2013 16:00'!
group: anObject
	group := anObject! !

!CIConfigurationSource methodsFor: 'initialize-release' stamp: 'ErwanDouaille 5/6/2013 13:11'!
initializeWithUrl: aUrl
	super initialize.
	self url: aUrl.
	self metacelloProject: (self loadDefaultConfiguration) project! !

!CIConfigurationSource methodsFor: 'initialize-release' stamp: 'ErwanDouaille 5/6/2013 13:10'!
initializeWithUrl: aUrl configurationName: aString
	super initialize.
	self url: aUrl.
	self metacelloProject: (self loadConfiguration: aString) project! !

!CIConfigurationSource methodsFor: 'private' stamp: 'ErwanDouaille 5/6/2013 11:08'!
listConfigurations
	| finalList |
	finalList := OrderedCollection new.
	self packageNames do:[:each | 
		finalList addIfNotPresent: (((each subStrings: '-') at:1) ).
	].
	^ finalList.! !

!CIConfigurationSource methodsFor: 'private' stamp: 'CamilloBruni 4/26/2013 16:35'!
loadConfiguration: aConfigurationName
	self gofer
		package: aConfigurationName;
		load.
	^ Smalltalk globals at: aConfigurationName asSymbol! !

!CIConfigurationSource methodsFor: 'private' stamp: 'ErwanDouaille 5/6/2013 11:22'!
loadDefaultConfiguration
	"Try to find a valid configuration in a repository
	1. use the repository name to deduce a valid configuration name
	2. or check all packages in the repository and use the single package starting with ConfigurationOf.."
	(self url asZnUrl lastPathSegment beginsWith: 'ConfigurationOf')
		ifTrue: [ ^ self loadConfiguration: (self url asZnUrl lastPathSegment) ].
	(self listConfigurations size = 1)
		ifFalse: [ ^ Error signal: 'The specified url does not contain a ConfigurationOf'  ].
	self loadConfiguration: (self listConfigurations at: 1).! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:28'!
metacelloProject
	^ metacelloProject! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:29'!
metacelloProject: aMetacelloProject
	metacelloProject := aMetacelloProject! !

!CIConfigurationSource methodsFor: 'private' stamp: 'ErwanDouaille 5/6/2013 11:08'!
packageNames
	| names fullName aStream |
	aStream := (ZnClient new get: self url) readStream.
	names := OrderedCollection new.
	[aStream atEnd] whileFalse:
		[[aStream upTo: $<. {$a. $A. nil} includes: aStream next] whileFalse.
		aStream upTo: $".
		aStream atEnd ifFalse: [
			fullName := aStream upTo: $".
			names add: fullName unescapePercents]].
	^ names select: [:each |  '*.mcz' match: each ]! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 13:06'!
publisher
	
	^ CICommandLinePublisher, CIHTMLPublisher, CIXMLPublisher ! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'ErwanDouaille 4/15/2013 13:41'!
validateChange: aConfiguration
	^ self validator validateChange: aConfiguration! !

!CIConfigurationSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:28'!
versions
	"reutrn all the version names in this configuration including symbolic names"
	self shouldBeImplemented! !

CIAbstractMonticelloSource subclass: #CIPharoSource
	instanceVariableNames: 'tracker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIPharoSource commentStamp: '<historical>' prior: 0!
I am specialized issue source for the Pharo Integration process. I load issues from the default pharo issue tracker (fogbugz) and I load the corresponding slices from the Pharo Inbox.!

!CIPharoSource class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/29/2013 00:24'!
pharo30
	^ self new
		url: 'http://smalltalkhub.com/mc/Pharo/Pharo30Inbox/main';
		tracker: FogBugzTracker pharo;
		yourself! !

!CIPharoSource methodsFor: 'delegating issue tracker' stamp: 'ErwanDouaille 4/11/2013 16:20'!
changeWithId: anInteger
	^ self wrapIssue: (self tracker issueWithId: anInteger)! !

!CIPharoSource methodsFor: 'delegating issue tracker' stamp: 'CamilloBruni 4/26/2013 16:27'!
changes
	^ self tracker openIssues collect: [ :trackerIssue | 
			self wrapIssue: trackerIssue ]! !

!CIPharoSource methodsFor: 'delegating issue tracker' stamp: 'CamilloBruni 4/9/2013 13:50'!
isAuthenticated
	^ self tracker isAuthenticated! !

!CIPharoSource methodsFor: 'loading' stamp: 'CamilloBruni 4/9/2013 13:54'!
loadSliceFor: anIssue from: gofer
	| match slices |
	
	match := 'SLICE-Issue-', anIssue id asString.
	slices := gofer allResolved select: [ :ref| ref name beginsWith: match].
	
	slices ifEmpty: [ ^ nil ].
	
	slices size == 1 ifTrue: [ ^ slices first ].
	
	"filter out local cache repositories"
	slices := slices reject: [ :goferReference| 
		goferReference repository isKindOf: MCCacheRepository ].
	
	" get the last version "
	^ (slices sort: [ :a :b | a versionNumber >= b versionNumber ]) first! !

!CIPharoSource methodsFor: 'delegating issue tracker' stamp: 'CamilloBruni 4/9/2013 13:50'!
logOnWithEmail: email password:  password
	^ self tracker logOnWithEmail: email password:  password! !

!CIPharoSource methodsFor: 'delegating issue tracker' stamp: 'ErwanDouaille 4/11/2013 16:22'!
nextIssueToBeChecked
	^ self wrapIssue: (self tracker nextIssueToBeChecked)! !

!CIPharoSource methodsFor: 'delegating issue tracker' stamp: 'CamilloBruni 4/14/2013 23:31'!
openIssues
	^ self tracker openIssues collect: [ :trackerIssue | 
			self wrapIssue: trackerIssue ]! !

!CIPharoSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 00:24'!
publisher
	^ CICommandLinePublisher, CIIssueTrackerPublisher! !

!CIPharoSource methodsFor: 'loading' stamp: 'CamilloBruni 4/26/2013 16:35'!
sliceFor: anIssue
	^ self loadSliceFor: anIssue from: self gofer! !

!CIPharoSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/9/2013 13:47'!
tracker
	^ tracker! !

!CIPharoSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/9/2013 13:47'!
tracker: anObject
	tracker := anObject! !

!CIPharoSource methodsFor: 'private' stamp: 'CamilloBruni 4/26/2013 16:36'!
wrapIssue: anIssue
	^ CISliceChange source: self case: anIssue ! !

!CIAbstractSource methodsFor: 'protocol' stamp: 'ErwanDouaille 4/11/2013 15:29'!
changeWithId: anId

	self subclassResponsibility! !

!CIAbstractSource methodsFor: 'testing' stamp: 'CamilloBruni 4/9/2013 13:49'!
isAuthenticated

	self subclassResponsibility! !

!CIAbstractSource methodsFor: 'log on/off' stamp: 'CamilloBruni 4/9/2013 13:49'!
logOnWithEmail: emailAddress password: password

	self subclassResponsibility! !

!CIAbstractSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:43'!
manager
	^ manager! !

!CIAbstractSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:43'!
manager: anObject
	manager := anObject! !

!CIAbstractSource methodsFor: 'protocol' stamp: 'CamilloBruni 4/9/2013 13:49'!
nextIssueToBeChecked
	
	self subclassResponsibility! !

!CIAbstractSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/9/2013 13:49'!
openIssues
	
	self subclassResponsibility! !

!CIAbstractSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:33'!
publisher
	"return a default CIPublisher for this source"
	^ self subclassResponsibility! !

CIAbstractSource subclass: #CITestSource
	instanceVariableNames: 'changeBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CITestSource commentStamp: '<historical>' prior: 0!
I am CI source used in tests. 
I generate changes by delegating to a Block.!

!CITestSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:46'!
changeBlock
	^ changeBlock! !

!CITestSource methodsFor: 'accessing' stamp: 'CamilloBruni 4/26/2013 16:46'!
changeBlock: anObject
	changeBlock := anObject! !

!CITestSource methodsFor: 'protocol' stamp: 'CamilloBruni 4/26/2013 16:43'!
changeWithId: anId
	^ changeBlock cull: anId! !

Object subclass: #CIAbstractTracker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIAbstractTracker commentStamp: '<historical>' prior: 0!
I am the abstract class used to define the API of the Issue Tracker!

!CIAbstractTracker methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 3/22/2013 18:24'!
isAuthenticated

	self subclassResponsibility! !

!CIAbstractTracker methodsFor: 'cases' stamp: 'ErwanDouaille 4/11/2013 15:35'!
issueWithId: anId

	self subclassResponsibility! !

!CIAbstractTracker methodsFor: 'log on/off' stamp: 'BenjaminVanRyseghem 3/22/2013 17:32'!
logOnWithEmail: emailAddress password: password

	self subclassResponsibility! !

!CIAbstractTracker methodsFor: 'cases' stamp: 'BenjaminVanRyseghem 3/22/2013 19:16'!
nextIssueToBeChecked
	
	self subclassResponsibility! !

!CIAbstractTracker methodsFor: 'accessing list' stamp: 'BenjaminVanRyseghem 3/22/2013 17:49'!
openIssues
	
	self subclassResponsibility! !

Object subclass: #CIAbstractValidationRule
	instanceVariableNames: 'change validationResult'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIAbstractValidationRule commentStamp: '<historical>' prior: 0!
I validate an issue and publish the results in a CIValidationResult.

A validation rule should be side-effect free so that they can be run in parallel.!

!CIAbstractValidationRule class methodsFor: 'combination' stamp: 'CamilloBruni 4/25/2013 14:13'!
& anotherRule
	^ self asCIValidationRule & anotherRule! !

!CIAbstractValidationRule class methodsFor: 'combination' stamp: 'CamilloBruni 4/20/2013 23:36'!
, anotherRule
	^ self asCIValidationRule, anotherRule asCIValidationRule! !

!CIAbstractValidationRule class methodsFor: 'conversion' stamp: 'CamilloBruni 4/20/2013 23:36'!
asCIValidationRule
	^ self new! !

!CIAbstractValidationRule class methodsFor: 'instance creation' stamp: 'ErwanDouaille 5/16/2013 14:42'!
change: aCase
self halt.
	^ self new
		change: aCase;
		yourself! !

!CIAbstractValidationRule class methodsFor: 'conversion' stamp: 'CamilloBruni 4/29/2013 14:10'!
harden
	^ self asCIValidationRule harden! !

!CIAbstractValidationRule class methodsFor: 'instance creation' stamp: 'ErwanDouaille 4/22/2013 10:05'!
selectTestCaseBlock: aBlock
	^ self new
		selectTestCaseBlock: aBlock;
		yourself! !

!CIAbstractValidationRule class methodsFor: 'conversion' stamp: 'CamilloBruni 4/29/2013 14:33'!
soften
	^ self asCIValidationRule soften! !

!CIAbstractValidationRule class methodsFor: 'validation' stamp: 'ErwanDouaille 4/23/2013 13:02'!
validate: aChange
	^ self asCIValidationRule 
		validate: aChange ! !

!CIAbstractValidationRule class methodsFor: 'combination' stamp: 'CamilloBruni 4/20/2013 23:36'!
| anotherRule
	^ self asCIValidationRule | anotherRule asCIValidationRule! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:36'!
& anotherRule
	^ anotherRule asCIValidationRule andWith: self! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:36'!
, anotherRule
	^ anotherRule asCIValidationRule addWith: self! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'ErwanDouaille 5/14/2013 14:44'!
addAllErrors: aCollection
	aCollection do: [ :error |
		self addError: error ]! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'CamilloBruni 4/29/2013 21:26'!
addAllMessages: aCollection
	aCollection do: [ :error |
		self addMessage: error ]! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'CamilloBruni 4/29/2013 21:26'!
addAllWarnings: aCollection
	aCollection do: [ :error |
		self addWarning: error ]! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'CamilloBruni 5/14/2013 14:11'!
addError: anError
	| index |
	
	self flag: 'ugly'.
	(anError isKindOf: Exception)
		ifFalse: [ ^ self validationResult addError: anError asString ].
		
	self flag: 'even uglier'.
	index := 1.
	self validationResult addError: (String streamContents: [ :stream | 
		stream tab print: anError; lf.
		(anError signalerContext contextStack first: 10) do: [ :context | 
			stream << (index asString padded: #left to: 2 with: $ ); << ':'; tab.	
			"indent the error string"
			stream << (context asString copyReplaceAll: String cr with: String lf , String tab); lf.
			index := index + 1 ].
		stream tab << '...' ])! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'CamilloBruni 5/11/2013 22:57'!
addMessage: message
	
	self validationResult addMessage: message asString! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'CamilloBruni 5/11/2013 21:06'!
addValidationResult: aCIValidationResult
	self validationResult, aCIValidationResult.
	^ self validationResult! !

!CIAbstractValidationRule methodsFor: 'adding' stamp: 'CamilloBruni 5/11/2013 22:57'!
addWarning: aWarning
	
	self validationResult addWarning: aWarning asString! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/25/2013 13:58'!
addWith: anotherRule
	^ CIListRule with: anotherRule with: self! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:34'!
addWithAll: anotherRule
	^ anotherRule add: self; yourself! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/25/2013 13:59'!
andWith: anotherRule
	^ CIAndRule with: anotherRule with: self! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:34'!
andWithAll: anotherRule
	^ anotherRule add: self; yourself! !

!CIAbstractValidationRule methodsFor: 'conversion' stamp: 'CamilloBruni 4/20/2013 23:37'!
asCIValidationRule
	^ self! !

!CIAbstractValidationRule methodsFor: 'validation' stamp: 'CamilloBruni 5/11/2013 22:33'!
assertHasChange
	self assert: change isNotNil description: 'No change given'.! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 16:14'!
change
	^ change! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'CamilloBruni 5/10/2013 19:28'!
change: anObject
	change := anObject asCIChange.
	self validationResult ifNotNil: [ 
		self validationResult change: change ]! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 14:16'!
errors
	^ self validationResult errors! !

!CIAbstractValidationRule methodsFor: 'conversion' stamp: 'CamilloBruni 4/29/2013 14:09'!
harden
	"Make this rule less permissive"
	^ CIWarningToErrorModifer rule: self! !

!CIAbstractValidationRule methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 5/11/2013 18:51'!
inform: aString
	self flag: 'for debugging'.
	VTermOutputDriver stderr
			nextPutAll: 'Notice: ';
			nextPutAll: aString asString; lf.! !

!CIAbstractValidationRule methodsFor: 'initialization' stamp: 'ErwanDouaille 5/7/2013 14:25'!
initialize
	super initialize.
	self validationResult: CIValidationResult new.! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'CI Validation User 5/8/2013 14:27'!
messages
	^ self validationResult messages! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/25/2013 13:59'!
orWith: anotherRule
	^ CIOrRule with: anotherRule with: self! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:34'!
orWithAll: anotherRule
	^ anotherRule add: self; yourself! !

!CIAbstractValidationRule methodsFor: 'conversion' stamp: 'CamilloBruni 4/29/2013 14:34'!
soften
	"Make this rule less permissive"
	^ CIErrorToWarningModifer rule: self! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'CamilloBruni 4/28/2013 23:53'!
timeout
	^ 20 minutes! !

!CIAbstractValidationRule methodsFor: 'validation' stamp: 'CamilloBruni 4/26/2013 14:59'!
timeoutFailure
	self addError: 'Timeout occured while loading ', self change name.! !

!CIAbstractValidationRule methodsFor: 'protocol' stamp: 'CamilloBruni 4/25/2013 22:11'!
validate
	^self subclassResponsibility! !

!CIAbstractValidationRule methodsFor: 'validation' stamp: 'CamilloBruni 5/16/2013 10:43'!
validate: aChange
	self change: aChange.
	self inform: 'Running ', self asString.
	[ Author useAuthor: 'CI Validation User' during: [ self validate ]] 
		valueWithin: self timeout 
		onTimeout: [ self timeoutFailure ].
	
	^ self validationResult! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 14:23'!
validationResult
	
	^ validationResult ! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'ErwanDouaille 5/7/2013 14:24'!
validationResult: aCIValidationResult
	validationResult := aCIValidationResult ! !

!CIAbstractValidationRule methodsFor: 'accessing' stamp: 'CI Validation User 5/8/2013 14:27'!
warnings
	^ self validationResult warnings! !

!CIAbstractValidationRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:36'!
| anotherRule
	^ anotherRule asCIValidationRule orWith: self! !

CIAbstractValidationRule subclass: #CIComposedRule
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIComposedRule commentStamp: '<historical>' prior: 0!
I am an abstract composed rule. 
I contain subrules that are evaluated in a certain manner see my subclasses for more implementations.!

CIComposedRule subclass: #CIAndRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIAndRule commentStamp: '<historical>' prior: 0!
I am a composed rule.
I only continue validating my subrules if all the previous subrules were successful.!

!CIAndRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:36'!
& anotherRule
	^ anotherRule asCIValidationRule andWithAll: self! !

!CIAndRule methodsFor: 'combining' stamp: 'CamilloBruni 4/25/2013 14:12'!
andWith: anotherRule
	self add: anotherRule! !

!CIAndRule methodsFor: 'private' stamp: 'CamilloBruni 4/20/2013 23:47'!
shouldContinueValidationWith: aCIValidationResult
	"Validate rules for as long as they succeed. Hence all rules after a failing result are ignored."
	^ aCIValidationResult isSuccess! !

!CIComposedRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/20/2013 23:24'!
with: aCIValidationRule
	^ self new
		add: aCIValidationRule;
		yourself! !

!CIComposedRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/20/2013 23:24'!
with: aCIValidationRule with: anotherCIValidationRule
	^ self new
		add: aCIValidationRule;
		add: anotherCIValidationRule;
		yourself! !

!CIComposedRule methodsFor: 'adding' stamp: 'CamilloBruni 4/20/2013 20:32'!
add: aValidationRule
	^ rules add: aValidationRule! !

!CIComposedRule methodsFor: 'initialize' stamp: 'CamilloBruni 4/20/2013 20:32'!
initialize
	super initialize.

	rules := OrderedCollection new.! !

!CIComposedRule methodsFor: 'accessing' stamp: 'ErwanDouaille 4/24/2013 15:22'!
rules
	^ rules! !

!CIComposedRule methodsFor: 'accessing' stamp: 'ErwanDouaille 4/24/2013 15:22'!
rules: anObject
	rules := anObject! !

!CIComposedRule methodsFor: 'private' stamp: 'CamilloBruni 4/20/2013 23:44'!
shouldContinueValidationWith: aCIValidationResult
	self subclassResponsibility! !

!CIComposedRule methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 22:33'!
validate
	| result |
	self assertHasChange.
	result := CIValidationResult new.
	
	self rules do: [ :validationRule |
		result := result, (validationRule validate: self change).
		(self shouldContinueValidationWith: result)
			ifFalse: [ ^ self addValidationResult: result ]].
	
	^  self addValidationResult: result.
	! !

CIComposedRule subclass: #CIListRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIListRule commentStamp: '<historical>' prior: 0!
I am a composed rule.
I validate a set of subrules and return their combined result.!

!CIListRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:36'!
, anotherRule
	^ anotherRule asCIValidationRule addWithAll: self! !

!CIListRule methodsFor: 'combining' stamp: 'CamilloBruni 4/25/2013 14:11'!
addWith: anotherRule
	self add: anotherRule! !

!CIListRule methodsFor: 'private' stamp: 'CamilloBruni 4/20/2013 23:44'!
shouldContinueValidationWith: aCIValidationResult
	^ true! !

CIComposedRule subclass: #CINotRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

CIComposedRule subclass: #CIOrRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIOrRule commentStamp: '<historical>' prior: 0!
I am a composed rule.
I only stop validating my subrules after the first succesfull result. !

!CIOrRule methodsFor: 'combining' stamp: 'CamilloBruni 4/25/2013 14:11'!
orWith: anotherRule
	self add: anotherRule! !

!CIOrRule methodsFor: 'private' stamp: 'CamilloBruni 4/20/2013 23:47'!
shouldContinueValidationWith: aCIValidationResult
	"As long as the intermediate result is a failure continue validating.
	Hence as soon as there is a positive result all the following rules are not validated."
	^ aCIValidationResult isFailure! !

!CIOrRule methodsFor: 'combining' stamp: 'CamilloBruni 4/20/2013 23:36'!
| anotherRule
	^ anotherRule asCIValidationRule orWithAll: self! !

CIAbstractValidationRule subclass: #CIRuleModifer
	instanceVariableNames: 'rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIRuleModifer commentStamp: '<historical>' prior: 0!
I modify the validation result of a given rule.!

CIRuleModifer subclass: #CIErrorToWarningModifer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIErrorToWarningModifer commentStamp: '<historical>' prior: 0!
I convert all the errors of the validation of a rule to warnings.!

!CIErrorToWarningModifer methodsFor: 'conversion' stamp: 'CamilloBruni 4/29/2013 14:35'!
harden
	^ self rule! !

!CIErrorToWarningModifer methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 21:15'!
modifyResult: aCIValidationResult
	| result |
	result := CIValidationResult new
		addAllWarnings: aCIValidationResult errors;
		addAllWarnings: aCIValidationResult warnings;
		addAllMessages: aCIValidationResult messages;
		yourself.
	^ self validationResult: result.! !

!CIErrorToWarningModifer methodsFor: 'printing' stamp: 'CamilloBruni 5/16/2013 09:28'!
printOn: asStream
	asStream print: self rule; << ' soften'.! !

!CIRuleModifer class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/30/2013 00:13'!
rule: aCIValidationRule
	^ self new
		rule: aCIValidationRule;
		yourself! !

!CIRuleModifer methodsFor: 'protocol' stamp: 'CamilloBruni 4/29/2013 14:06'!
modifyResult: aCIValidationResult
	^ self subclassResponsibility! !

!CIRuleModifer methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 14:04'!
rule
	^ rule! !

!CIRuleModifer methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 14:04'!
rule: anObject
	rule := anObject! !

!CIRuleModifer methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 22:33'!
validate
	self assertHasChange.
	^ self modifyResult: (self rule validate: self change)! !

CIRuleModifer subclass: #CIWarningToErrorModifer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIWarningToErrorModifer commentStamp: '<historical>' prior: 0!
I convert all the warnings of the validation of a rule to errors.!

!CIWarningToErrorModifer methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 21:16'!
modifyResult: aCIValidationResult
	| result |
	result := CIValidationResult new
		addAllErrors: aCIValidationResult errors;
		addAllErrors: aCIValidationResult warnings;
		addAllMessages: aCIValidationResult messages;
		yourself.
	^ self validationResult: result! !

!CIWarningToErrorModifer methodsFor: 'printing' stamp: 'CamilloBruni 5/16/2013 09:28'!
printOn: asStream
	asStream print: self rule; << ' harden'.! !

!CIWarningToErrorModifer methodsFor: 'conversion' stamp: 'CamilloBruni 4/29/2013 14:35'!
soften
	^ self rule! !

CIAbstractValidationRule subclass: #CITestChangeDifferenceRule
	instanceVariableNames: 'loadTime environmentChange previousResult imageForker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CITestChangeDifferenceRule commentStamp: '<historical>' prior: 0!
A CIWithPreRunnedRule is an abstract which defines a specific comportment for rules which run test before load changements.
!

CITestChangeDifferenceRule subclass: #CIRunTestsRule
	instanceVariableNames: 'selectTestCaseBlock testErrors testFailures'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIRunTestsRule commentStamp: '<historical>' prior: 0!
I load a case source in a separate image and publish the test results.!

!CIRunTestsRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 5/10/2013 16:24'!
packagePrefix: aString
	^ self selectTestCaseBlock: [ :case |
		case package name beginsWith: aString ]! !

!CIRunTestsRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/15/2013 10:09'!
selectTestCaseBlock: aBlock
	^ self new
		 	selectTestCaseBlock: aBlock;
			yourself! !

!CIRunTestsRule methodsFor: 'validation' stamp: 'CamilloBruni 5/11/2013 20:16'!
basicValidate
	| suite result |
	
	suite := TestSuite new.
	
	TestCase allSubclasses 
		select: self selectTestCaseBlock
		thenDo: [ :testClass |
			testClass isAbstract 
				ifFalse: [ suite addTests: testClass suite tests ]].
	
	result := 	CITestResult new.
	result maxTest: suite tests size.
 	suite run: result.
	
	self testResult: result.
	^ self validationResult! !

!CIRunTestsRule methodsFor: 'initialize-release' stamp: 'CamilloBruni 5/10/2013 13:08'!
defaultSelectTestCaseBlock
	"I return a default test block that filters out certain packages that would cause trouble when testing during a validation process."
	^ [ :testCaseClass | 
		#('CI-' 'OSProcess-' 'CommandShell-' ) noneSatisfy: [ :packagePrefix |
			testCaseClass package name beginsWith: packagePrefix ]]! !

!CIRunTestsRule methodsFor: 'accessing' stamp: 'CI Validation User 5/9/2013 21:57'!
filePrefix
	| imageName originalPrefix |
	
	imageName := Smalltalk imageFile basenameWithoutExtension.
	originalPrefix := super filePrefix.
	
	(originalPrefix = imageName)
		ifFalse: [ ^ originalPrefix ].
		
	^ imageName, '_', originalPrefix
		! !

!CIRunTestsRule methodsFor: 'initialize-release' stamp: 'CamilloBruni 5/10/2013 13:05'!
initialize
	super initialize.
	"Do not run the CI tests by default"
	selectTestCaseBlock := self defaultSelectTestCaseBlock! !

!CIRunTestsRule methodsFor: 'validation' stamp: 'CamilloBruni 5/17/2013 21:38'!
preLoadValidate
	"Unlike the standard CITestChangeDifferenceRule tests should not be run twice in the same image.
	Hence we launch the first test in yet another image"
	^ previousResult := CIImageForker newImageDo: [ self basicValidate ].! !

!CIRunTestsRule methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 19:16'!
selectTestCaseBlock
	^ selectTestCaseBlock! !

!CIRunTestsRule methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 22:25'!
selectTestCaseBlock: aSelectBlock
	selectTestCaseBlock := aSelectBlock! !

!CIRunTestsRule methodsFor: 'validation' stamp: 'CamilloBruni 5/11/2013 20:41'!
testResult: aTestResult
	"process the test results "
	self 
		addAllErrors: aTestResult failures;
		addAllErrors: aTestResult errors;
		addAllWarnings: aTestResult skipped.! !

CITestChangeDifferenceRule subclass: #CISmallIntRule
	instanceVariableNames: 'rules'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CISmallIntRule commentStamp: '<historical>' prior: 0!
A CISmallIntRule is responsible to run smallint rules and report the results.!

!CISmallIntRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/26/2013 14:00'!
with: aRule
	^ self new
		add: aRule;
		yourself! !

!CISmallIntRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/26/2013 14:01'!
with: aRule with: anotherRule
	^ self new
		add: aRule;
		add: anotherRule;
		yourself! !

!CISmallIntRule methodsFor: 'accessing' stamp: 'ErwanDouaille 5/14/2013 13:31'!
add: aRule
	self rules add: aRule! !

!CISmallIntRule methodsFor: 'as yet unclassified' stamp: 'ErwanDouaille 5/14/2013 16:23'!
basicValidate

	self testResult: self runRules.
	^ self validationResult.! !

!CISmallIntRule methodsFor: 'as yet unclassified' stamp: 'ErwanDouaille 5/14/2013 13:32'!
initialize
	super initialize.
	self rules: OrderedCollection new.! !

!CISmallIntRule methodsFor: 'accessing' stamp: 'ErwanDouaille 5/14/2013 13:20'!
rules
	^ rules! !

!CISmallIntRule methodsFor: 'accessing' stamp: 'ErwanDouaille 5/14/2013 13:20'!
rules: anObject
	rules := anObject! !

!CISmallIntRule methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 5/16/2013 11:19'!
runRules
	| result |
	result := OrderedCollection new.
	self rules do: [ :rule |
		result add: rule run result ].
	^ result! !

!CISmallIntRule methodsFor: 'as yet unclassified' stamp: 'ErwanDouaille 5/14/2013 22:45'!
testResult: aSmallIntResult

	aSmallIntResult do: [ :each |
		each classes do: [ :class |
			self addWarning: each label asString, ' ', class asString ]].! !

!CITestChangeDifferenceRule methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 20:17'!
basicValidate
	"Basic validate should build up and return a validation result."
	self shouldBeImplemented! !

!CITestChangeDifferenceRule methodsFor: 'accessing' stamp: 'CamilloBruni 4/29/2013 21:16'!
environmentCopy
	self flag: 'To be implemented properly'.
	^ RPackageOrganizer default copy! !

!CITestChangeDifferenceRule methodsFor: 'false positive handling' stamp: 'CamilloBruni 4/29/2013 21:10'!
falsePositives: falsePositives includesResult: result
	^ falsePositives includes: result! !

!CITestChangeDifferenceRule methodsFor: 'accessing' stamp: 'ErwanDouaille 5/17/2013 14:18'!
imageForker
	^ imageForker! !

!CITestChangeDifferenceRule methodsFor: 'initialization' stamp: 'CamilloBruni 5/17/2013 20:46'!
initialize
	super initialize.
	imageForker := CIImageForker new.
	imageForker timeout: self timeout.! !

!CITestChangeDifferenceRule methodsFor: 'accessing' stamp: 'CamilloBruni 4/25/2013 22:26'!
loadTime
	^ loadTime! !

!CITestChangeDifferenceRule methodsFor: 'validation' stamp: 'CamilloBruni 5/17/2013 18:37'!
newImageDo: aBlock
	| result |
	
	result := self imageForker newImageDo: aBlock.
	
	^ result! !

!CITestChangeDifferenceRule methodsFor: 'validation' stamp: 'CamilloBruni 5/11/2013 20:16'!
postLoadValidate
	"Run the validation checks after loading the change"
	^ self basicValidate! !

!CITestChangeDifferenceRule methodsFor: 'validation' stamp: 'CamilloBruni 5/11/2013 20:17'!
preLoadValidate
	"Run the validation before loading the change and store the intermediate validation result for later removal of false-positives"
	^ previousResult := self basicValidate copy.! !

!CITestChangeDifferenceRule methodsFor: 'validation' stamp: 'CamilloBruni 5/11/2013 22:26'!
recordEnvironmentChangeDuring: aChangeBlock
	| oldEnvironment |
	"oldEnvironment := self environmentCopy."
	aChangeBlock value.
	"environmentChange := CIEnvironmentChange from: oldEnvironment to: self environmentCopy."! !

!CITestChangeDifferenceRule methodsFor: 'validation' stamp: 'CamilloBruni 5/14/2013 13:23'!
recordValidationChangesDuring: aBlock
	self preLoadValidate.
	self inform: 'Loading change.'.
	
	[[ loadTime := aBlock timeToRun ]
		on: Error, Warning do: [ :error |
			^ self addError: (String streamContents: [ :stream |
				stream << 'Could not apply change: '; print: error.
				error signalerContext shortDebugStackOn: stream ])]
	] on: Exception do: [ :e|
		self inform: '   loading signalled ', e asString.
		e pass ].
	
	self inform: 'Loaded change in ', loadTime asString, ' ms'.
	self 
		postLoadValidate;
		removeFalsePositives.! !

!CITestChangeDifferenceRule methodsFor: 'false positive handling' stamp: 'CamilloBruni 5/9/2013 14:16'!
removeFalsePositives
	previousResult 
		ifNil: [ ^ self ].

	validationResult errors: (self 
		removeFalsePositives: previousResult errors 
		from: self errors).
		
	validationResult warnings: (self 
		removeFalsePositives: previousResult warnings 
		from: self warnings).
		
	validationResult messages: (self 
		removeFalsePositives: previousResult messages 
		from: self messages).
		
	 
		! !

!CITestChangeDifferenceRule methodsFor: 'false positive handling' stamp: 'CamilloBruni 4/29/2013 21:04'!
removeFalsePositives: falsePositives from: results
	
	^ results reject: [ :each || detected |
		self falsePositives: falsePositives includesResult: each ].
	! !

!CITestChangeDifferenceRule methodsFor: 'protocol' stamp: 'CamilloBruni 5/17/2013 18:37'!
validate
	| result |
	
	self assertHasChange.

	result := self newImageDo: [ 
		self validateChangeBlock: [ self change load ]].
	
	^ self addValidationResult: result! !

!CITestChangeDifferenceRule methodsFor: 'validation' stamp: 'ErwanDouaille 5/14/2013 15:29'!
validateChangeBlock: aChangeBlock
	[ 
		self recordEnvironmentChangeDuring: [
			self recordValidationChangesDuring: aChangeBlock ]
	] on: Error, Exit do: [ :e | 
		self addError: e ].
	
	^ self validationResult! !

CIAbstractValidationRule subclass: #CITestRule
	instanceVariableNames: 'block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CITestRule commentStamp: '<historical>' prior: 0!
I am very generic validation rule that takes a block and evaluates it with a change.

Example: 
	[ :change | CIValidationResult new ] asCIValidationRule!

!CITestRule class methodsFor: 'conversion' stamp: 'CamilloBruni 4/20/2013 23:36'!
asCIValidationRule
	Error signal: 'Cannot create default instance of CIBlockRule, do not use the Class as a rule'! !

!CITestRule class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/20/2013 23:20'!
block: aBlock
	^ self new
		block: aBlock;
		yourself! !

!CITestRule methodsFor: 'accessing' stamp: 'CamilloBruni 4/20/2013 23:20'!
block
	^ block! !

!CITestRule methodsFor: 'accessing' stamp: 'CamilloBruni 4/20/2013 23:20'!
block: anObject
	block := anObject! !

!CITestRule methodsFor: 'protocol' stamp: 'CamilloBruni 5/11/2013 22:37'!
validate
	self assertHasChange.
	^ self block ifNotNil: [ 
		self addValidationResult: (self block cull: self change) ]! !

Object subclass: #CIChangeManager
	instanceVariableNames: 'validator source publisher'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!CIChangeManager commentStamp: '<historical>' prior: 0!
I am in charge of loading an issue for my tracker and then provide it to the validator, and finally update the tracker according to the validator result.

My scenario is:
	1) log on to the tracker
	2) fetch the next interesting issue, the logic of which one is interesting or not depends on me only. The tracker should not know about this at all
	3) load latest slice (yes, we drop cs files)
	4) provide it to the validator
	5) get results from the validator
	6) update the issue
	7) log off and let another instance do the next issue!

!CIChangeManager class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/9/2013 13:43'!
pharo
	^ self pharo30! !

!CIChangeManager class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/14/2013 21:33'!
pharo30
	^ self 
		source: CIPharoSource pharo30
		validator: CIValidator pharo30! !

!CIChangeManager class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/14/2013 21:33'!
source: anIssueSource validator: aCIValidator
	
	^ self new
		source: anIssueSource;
		validator: aCIValidator;
		publisher: anIssueSource publisher;
		yourself! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'ErwanDouaille 5/6/2013 14:42'!
changeWithGroup: aString

	^ self source group: aString! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'ErwanDouaille 4/11/2013 15:29'!
changeWithId: anInteger

	^ self source changeWithId: anInteger! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'CamilloBruni 4/9/2013 13:48'!
isAuthenticated
	
	^ self source isAuthenticated! !

!CIChangeManager methodsFor: 'log on/off' stamp: 'BenjaminVanRyseghem 3/22/2013 17:35'!
logOn

	self tracker logOnWithEmail: self emailAddress password: self password! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'CamilloBruni 4/9/2013 13:48'!
logOnWithEmail: email password:  password

	^ self source logOnWithEmail: email password: password! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'CamilloBruni 4/9/2013 13:48'!
nextIssueToBeChecked

	^ self source nextIssueToBeChecked! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'CamilloBruni 4/9/2013 13:48'!
openIssues

	^ self source openIssues! !

!CIChangeManager methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:28'!
publisher
	^ publisher! !

!CIChangeManager methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:43'!
publisher: aCIPublisher
	publisher := aCIPublisher.
	publisher manager: self! !

!CIChangeManager methodsFor: 'accessing' stamp: 'CamilloBruni 4/9/2013 13:46'!
source
	^ source! !

!CIChangeManager methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:44'!
source: aCIIssueSource
	source := aCIIssueSource.
	source manager: self.! !

!CIChangeManager methodsFor: 'delegate issue source' stamp: 'ErwanDouaille 4/11/2013 16:13'!
validateChange: aCase
	^ self validator validateChange: aCase! !

!CIChangeManager methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/22/2013 17:48'!
validator
	^ validator! !

!CIChangeManager methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:42'!
validator: aCIValidator
	validator := aCIValidator.
	validator manager: self.! !

Object subclass: #CIConfigurationExemple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CIConfigurationExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:53'!
exampleDefault
	| collection arguments  |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.	
	collection add: 'ConfigurationOfPastell'.
	
	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments.! !

!CIConfigurationExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:53'!
exampleGroup
	| collection arguments  |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.	
	collection add: 'ConfigurationOfPastell'.
	collection add: '--group=Tests'.

	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments.! !

!CIConfigurationExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:53'!
exampleVersion
	| collection arguments |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.
	collection add: 'ConfigurationOfPastell'.
	collection add: '--version=1.3'.
	
	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments! !

!CIConfigurationExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:52'!
exampleVersionGroup
	| collection arguments  |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.	
	collection add: 'ConfigurationOfPastell'.
	collection add: '--version=1.3'.
	"collection add: '--version=1.2'. should not work because there is no Tests package in 1.2"
	collection add: '--group=Tests'.

	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments.! !

Object subclass: #CIImageForker
	instanceVariableNames: 'communicationPort readSocket timeout filePrefix'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIImageForker commentStamp: '<historical>' prior: 0!
I'm an abstraction which provide default way to fork the current image and run a block.

Example: 
"CIImageForkerBlock is a subclass wich implement needed stuff"
CIImageForkerBlock forkDo: [ 1+2 ]

Should result 3 :)

Extension for block provide : [ 1+2 ] valueInForkedImage !

!CIImageForker class methodsFor: 'as yet unclassified' stamp: 'CamilloBruni 5/17/2013 18:35'!
newImageDo: aBlock 
	^ self new newImageDo: aBlock! !

!CIImageForker methodsFor: 'image forking' stamp: 'CamilloBruni 5/17/2013 21:20'!
assertNoExistingImage
	
	self 
		assert: self temporaryChangesFile exists not 
		description: self temporaryChangesFile basename, ' exists already'..
	self 
		assert: self temporaryImageFile exists not
		description: self temporaryImageFile basename, ' exists already'.! !

!CIImageForker methodsFor: 'image forking' stamp: 'CamilloBruni 5/17/2013 21:20'!
backupNewTemporaryImage
	| oldImageName newImageName |
	self assertNoExistingImage.
	
	newImageName := self temporaryImageName.
	oldImageName := Smalltalk shortImageName.
	^ Smalltalk backupTo: newImageName! !

!CIImageForker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/17/2013 10:29'!
communicationPort
	^ communicationPort! !

!CIImageForker methodsFor: 'image forking' stamp: 'ErwanDouaille 5/17/2013 15:18'!
createStderrForwarderForProcess: forkedImage
	^ [ 
	[ 
	forkedImage pipeFromError
		ifNotNil: [ :pipe | 
			[ 
			FileStream stderr
				nextPutAll: (pipe next: 16);
				flush;flush ]
				on: Error
				do: [ :err | "nothing"] ] ] repeat ] fork! !

!CIImageForker methodsFor: 'image forking' stamp: 'CamilloBruni 5/17/2013 21:18'!
deleteTemporaryImage
	self temporaryChangesFile ensureDeleted.
	self temporaryImageFile ensureDeleted.	! !

!CIImageForker methodsFor: 'accessing' stamp: 'CamilloBruni 5/21/2013 15:27'!
filePrefix
	^ filePrefix ifNil: [
		filePrefix := Smalltalk imageFile nextVersion basenameWithoutExtension, '_fork_', SmallInteger maxVal atRandom asString ]! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'ErwanDouaille 5/17/2013 11:41'!
handleExitStatus: forkedImageProces
	self waitForProcess: forkedImageProces.
	forkedImageProces succeeded
		ifTrue: [ ^ self ].
	self inform: ' failed: test image was terminated with signal ' , forkedImageProces processProxy exitStatus asString! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'ErwanDouaille 5/17/2013 10:29'!
handleResultFromForkedImage: forkedImage
	
	self prepareListenSocket.
	^ self readResultFromForkedImage: forkedImage! !

!CIImageForker methodsFor: 'image forking' stamp: 'CamilloBruni 5/17/2013 21:27'!
newImageDo: aBlock
	self restoreCommunicationPortAfter: [
		self 
			spawnImageNewSessionDo: [ self runForkedImage: aBlock ]
			currentSessionDo: [ ^ self runNewImage ]].! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'CamilloBruni 5/17/2013 21:55'!
newReadSocketStream
	^ (SocketStream on: readSocket) 
		timeout: 10;
		binary;
		yourself! !

!CIImageForker methodsFor: 'result handling forked image' stamp: 'ErwanDouaille 5/17/2013 10:29'!
newWriteSocketStream
	"create a new socket stream to communicate back to the main image"
	^ (SocketStream openConnectionToHost: #[ 127 0 0 1] port: self communicationPort) 
		binary! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'ErwanDouaille 5/17/2013 10:29'!
openCommunicationSocket

	readSocket := Socket newTCP.
	"chose a random port"
	readSocket listenOn: 0.
	communicationPort := readSocket port.! !

!CIImageForker methodsFor: 'image forking' stamp: 'ErwanDouaille 5/17/2013 10:29'!
prepareListenSocket
	
	| oldSocket |
	readSocket closeAndDestroy.
	oldSocket := Socket newTCP.
	oldSocket  listenOn: self communicationPort backlogSize: 10.
	readSocket := oldSocket waitForAcceptFor: self timeout asSeconds.
	oldSocket closeAndDestroy.! !

!CIImageForker methodsFor: 'result handling forked image' stamp: 'CamilloBruni 5/17/2013 20:52'!
publishResult: aBlock
	| oldGlobals newGlobals globals result |
	
	oldGlobals := Smalltalk globals asSet.
	[ result := aBlock value ]
		on: Error do: [ :error | result := error ].
	"For stability reason avoid rehashing before filtering the globals as there
	might be objects without proper hashes in there, strange case, but it has happened "
	newGlobals := Set new.
	Smalltalk globals valuesDo: [ :global | 
		global isBehavior
			ifTrue: [ newGlobals add: global ]].
		
	globals := newGlobals \ oldGlobals.
	
	self inform: 'B: Publishing result: ', result asString.
	self serializeGlobals: globals result: result! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'CamilloBruni 5/17/2013 21:56'!
readResultFromForkedImage: forkedImage
	| result communicationStream ack |
	
	self inform: 'A: Waiting for test image results...'.
	
	communicationStream := self newReadSocketStream.
	self inform: 'A: Writing READY'.
	communicationStream nextPutAll: 'READY'; flush.
	self inform: 'A: Waiting for ACK'.
	self 
		assert: (ack := communicationStream next: 3) asString = 'ACK' 
		description: 'A: Expected ACK but got ', ack printString.
	[ 
		self inform: 'A: Reading result'.
		"fuel bug prevents us from serializing all values directly, need to handle the globals first"
		result := (FLMaterializer newDefault materializeFrom: communicationStream) root second.
		^ result
	] ensure: [ 
		self inform: 'A: Writing OK'.
		communicationStream nextPutAll: 'OK'; flush.
		communicationStream close. ]! !

!CIImageForker methodsFor: 'protocol' stamp: 'ErwanDouaille 5/17/2013 10:29'!
restoreCommunicationPortAfter: aBlock
	| oldCommunicationPort |
	
	oldCommunicationPort := self communicationPort.
	
	^ aBlock ensure: [
		oldCommunicationPort ifNotNil: [ 
			communicationPort := oldCommunicationPort ]]! !

!CIImageForker methodsFor: 'result handling forked image' stamp: 'CamilloBruni 5/17/2013 21:28'!
runForkedImage: aBlock
	
	[ self publishResult: aBlock. ] ensure: [ 
		self inform: 'B: Terminating'.
		Smalltalk snapshot: false andQuit: true.
		Error signal: 'should not reopen forked validation image' ]! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'CamilloBruni 5/21/2013 16:08'!
runNewImage
	| relayOutput forkedImage |
	self 
		assert: self temporaryChangesFile exists;
		assert: self temporaryImageFile exists.
	
	forkedImage := PipeableOSProcess command: self temporaryImageCommand.
	relayOutput := self createStderrForwarderForProcess: forkedImage.
	
	[ ^ self handleResultFromForkedImage: forkedImage ]
		ensure: [ 
		relayOutput terminate.
		readSocket ifNotNil: [ readSocket closeAndDestroy ].
		self handleExitStatus: forkedImage.
		self deleteTemporaryImage ]! !

!CIImageForker methodsFor: 'result handling forked image' stamp: 'ErwanDouaille 5/17/2013 10:43'!
serializeGlobals: globals result: result
	| serializer stream  ack |
	
	stream := self newWriteSocketStream. 
	self inform: 'B: Waiting for READY'.
	ack :=  (stream next: 5) asString.
	self assert: ack = 'READY' description: 'Expected READY but got ', ack printString.
	self inform: 'B: Writing ACK'.
	stream nextPutAll: 'ACK'; flush.
	
	self inform: 'B: Writing result '.
	serializer := FLSerializer newDefault.
	serializer analyzer considerInternalAllBehaviors: globals.
	[ 
		serializer
			serialize: { globals. result }
			on: stream.
		stream flush.
	
		serializer 
			serialize: { globals. result }
			toFileNamed: DateAndTime now asString, '.fuel'.
		
	] on: Error do: [ :error|
		self inform: 'B: got error during serialization: ', error printString ].
	self inform: 'B: Waiting for OK'.
	
	stream next: 2.
	self inform: 'B: Got OK'.! !

!CIImageForker methodsFor: 'image forking' stamp: 'ErwanDouaille 5/17/2013 10:29'!
spawnImageNewSessionDo: newSessionBlock  currentSessionDo: currentSessionBlock
	self openCommunicationSocket.
	self inform: 'Creating test image'.
	self backupNewTemporaryImage
		ifTrue: newSessionBlock 
		ifFalse: currentSessionBlock! !

!CIImageForker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/17/2013 10:29'!
tempFile
	^ self filePrefix asFileReference! !

!CIImageForker methodsFor: 'accessing' stamp: 'CamilloBruni 5/17/2013 21:16'!
temporaryChangesFile
	"return the FileReference to the newly created test image "
	^ Smalltalk fileForChangesNamed: self temporaryImageName! !

!CIImageForker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/17/2013 10:29'!
temporaryImageCommand
	^ Smalltalk vm command, ' ', self temporaryImageFile fullName.! !

!CIImageForker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/17/2013 10:29'!
temporaryImageFile
	"return the FileReference to the newly created test image "
	^ Smalltalk fileForImageNamed: self temporaryImageName! !

!CIImageForker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/17/2013 10:29'!
temporaryImageName
	^ self filePrefix! !

!CIImageForker methodsFor: 'accessing' stamp: 'CamilloBruni 5/17/2013 18:30'!
timeout
	^ timeout ifNil: [ 2 minutes ]! !

!CIImageForker methodsFor: 'accessing' stamp: 'CamilloBruni 5/17/2013 18:30'!
timeout: aDuration
	timeout := aDuration! !

!CIImageForker methodsFor: 'result handling main image' stamp: 'CamilloBruni 5/17/2013 21:28'!
waitForProcess: forkedImage
	[ 10 milliSeconds wait.
	forkedImage isComplete ] whileFalse! !

!CIImageForker methodsFor: 'image forking' stamp: 'ErwanDouaille 5/17/2013 10:29'!
waitForReadySignal
	"wait for the parent image's signal that it is ready to receive the validation result"
	[ FileStream stdin binary next = 1 ] whileFalse! !

Object subclass: #CISliceExemple
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Test'!

!CISliceExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:54'!
exampleDefault
	| collection arguments  |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.	
	collection add: 'ConfigurationOfPastell'.
	
	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments.! !

!CISliceExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:54'!
exampleGroup
	| collection arguments  |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.	
	collection add: 'ConfigurationOfPastell'.
	collection add: '--group=Tests'.

	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments.! !

!CISliceExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:54'!
exampleVersion
	| collection arguments |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.
	collection add: 'ConfigurationOfPastell'.
	collection add: '--version=1.3'.
	
	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments! !

!CISliceExemple methodsFor: 'tests' stamp: 'ErwanDouaille 5/7/2013 15:54'!
exampleVersionGroup
	| collection arguments  |
	collection := OrderedCollection new.
	collection add: 'config'.
	collection add: 'http://smalltalkhub.com/mc/PharoExtras/Pastell/main'.	
	collection add: 'ConfigurationOfPastell'.
	collection add: '--version=1.3'.
	"collection add: '--version=1.2'. should not work because there is no Tests package in 1.2"
	collection add: '--group=Tests'.

	arguments := CommandLineArguments withArguments: collection.
	CICommandLineHandler activateWith: arguments.! !

Object subclass: #CIValidationResult
	instanceVariableNames: 'warnings messages change errors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIValidationResult commentStamp: '<historical>' prior: 0!
I collect results from different CIValidators!

!CIValidationResult class methodsFor: 'instance creation' stamp: 'ErwanDouaille 4/11/2013 16:02'!
change: aCase
	^ self new 
		change: aCase;
		yourself! !

!CIValidationResult class methodsFor: 'instance creation' stamp: 'CamilloBruni 5/9/2013 14:15'!
failure: aMessage
	^ self new
		addError: aMessage;
		yourself! !

!CIValidationResult class methodsFor: 'instance creation' stamp: 'ErwanDouaille 5/2/2013 15:58'!
message: aMessage
	^ self new
		addMessage: aMessage;
		yourself! !

!CIValidationResult class methodsFor: 'instance creation' stamp: 'ErwanDouaille 5/2/2013 15:58'!
warning: aMessage
	^ self new
		addWarning: aMessage;
		yourself! !

!CIValidationResult methodsFor: 'concatenation' stamp: 'CamilloBruni 5/9/2013 14:16'!
, aCIValidationResult 
	errors addAll: aCIValidationResult errors.
	warnings addAll: aCIValidationResult warnings.
	messages addAll: aCIValidationResult messages.! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 14:16'!
addAllErrors: aCollection
	self errors addAll: aCollection! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 4/15/2013 14:56'!
addAllMessages: aCollection 
	self messages addAll: aCollection! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 4/15/2013 14:56'!
addAllWarnings: aCollection 
	self warnings addAll: aCollection! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 14:15'!
addError: aMessage
	errors add: aMessage! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 16:06'!
addMessage: aMessage
	messages add: aMessage! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 16:06'!
addWarning: aMessage
	warnings add: aMessage! !

!CIValidationResult methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 16:02'!
change
	^ change! !

!CIValidationResult methodsFor: 'accessing' stamp: 'ErwanDouaille 4/11/2013 16:02'!
change: anObject
	change := anObject! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 5/9/2013 14:16'!
errorString
	^ String streamContents: [ :str |
		self printErrorsOn: str ]! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 14:16'!
errors
	^ errors! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 5/9/2013 14:16'!
errors: aCollection
	errors := aCollection.! !

!CIValidationResult methodsFor: 'testing' stamp: 'CamilloBruni 5/9/2013 14:16'!
hasErrors
	^ self errors isEmpty not.! !

!CIValidationResult methodsFor: 'testing' stamp: 'ErwanDouaille 4/30/2013 17:29'!
hasMessages
	^ self messages isEmpty not.! !

!CIValidationResult methodsFor: 'testing' stamp: 'ErwanDouaille 4/30/2013 17:29'!
hasWarnings
	^ self warnings isEmpty not.! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 4/15/2013 15:33'!
htmlString
	| string |
	string := self printString.
	^ string copyReplaceAll: String cr with: '<br/>'.
	! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 4/15/2013 15:28'!
htmlStringOn: aStream
	^ self printOn: aStream! !

!CIValidationResult methodsFor: 'initialize' stamp: 'CamilloBruni 5/9/2013 14:15'!
initialize
	super initialize.

	errors := OrderedCollection new.
	messages := OrderedCollection new.
	warnings := OrderedCollection new.! !

!CIValidationResult methodsFor: 'testing' stamp: 'ErwanDouaille 4/30/2013 17:27'!
isFailure 
	^ self isSuccess not! !

!CIValidationResult methodsFor: 'testing' stamp: 'CamilloBruni 5/9/2013 14:16'!
isSuccess
	^ self errors isNil or: [ self errors isEmpty ]! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 14:45'!
messages
	^ messages! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CI Validation User 5/8/2013 14:26'!
messages: aCollection
	messages := aCollection.! !

!CIValidationResult methodsFor: 'copying' stamp: 'CamilloBruni 5/9/2013 14:15'!
postCopy
	super postCopy.
	errors := errors copy.
	warnings := warnings copy.
	messages := messages copy.! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 5/9/2013 14:16'!
printErrorsOn: aStream
	self printList: self errors named: 'Failures' on: aStream.! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 4/15/2013 14:27'!
printList: aList named: name on: aStream
	aList ifEmpty: [ ^ self ].
	
	aStream 
		nextPutAll: name; cr;
		nextPutAll: ('' padLeftTo: name size with: $-); cr.
	aList
		do: [ :item | item printOn: aStream ]
		separatedBy: [ aStream cr ]! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 4/15/2013 14:26'!
printMessagesOn: aStream
	self printList: self messages named: 'Messages' on: aStream.! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 5/9/2013 14:16'!
printOn: aStream
	self 
		printErrorsOn: aStream;
		printWarningsOn: aStream;
		printMessagesOn: aStream! !

!CIValidationResult methodsFor: 'printing' stamp: 'CamilloBruni 4/15/2013 14:26'!
printWarningsOn: aStream
	self printList: self warnings named: 'Warnings' on: aStream.! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 14:45'!
warnings
	^ warnings! !

!CIValidationResult methodsFor: 'accessing' stamp: 'CI Validation User 5/8/2013 14:25'!
warnings: aCollection
	warnings := aCollection.! !

Object subclass: #CIValidator
	instanceVariableNames: 'rules manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!CIValidator commentStamp: '<historical>' prior: 0!
I validate a given case using CIValidationRules!

!CIValidator class methodsFor: 'instance creation' stamp: 'ErwanDouaille 5/15/2013 15:18'!
configuration
		
	"past one, new version is using SmallintRules :)
	^ self new
		addRule: CIClassCommentRule & CIUncategorizedMethodRule;
		yourself"
		
	^ self new
		addRule: 
			RBUnclassifiedMethodsRule harden & 
			RBNoClassCommentRule harden;
		yourself! !

!CIValidator class methodsFor: 'instance creation' stamp: 'CamilloBruni 4/14/2013 21:42'!
manager: aCIChecker
	^ self new	
		manager: aCIChecker;
		yourself! !

!CIValidator class methodsFor: 'instance creation' stamp: 'CamilloBruni 5/16/2013 10:52'!
pharo30
	^ self new
		addRule: 
			CIRunTestsRule,
			RBCompositeLintRule pharoHardLintRules harden,
			RBCompositeLintRule pharoSoftLintRules;
		yourself! !

!CIValidator class methodsFor: 'instance creation' stamp: 'ErwanDouaille 5/6/2013 11:25'!
slice
	^self pharo30 ! !

!CIValidator methodsFor: 'accessing' stamp: 'CamilloBruni 4/10/2013 14:38'!
addRule: aCIValidationRule
	rules add: aCIValidationRule! !

!CIValidator methodsFor: 'validation' stamp: 'ErwanDouaille 4/16/2013 12:48'!
asertLoadable: aChange
	aChange isLoadable 
		ifTrue: [ ^ self ].
	self publishChangeNotFound: aChange.
"	aChange assertLoadable."! !

!CIValidator methodsFor: 'initialize-release' stamp: 'CamilloBruni 4/9/2013 14:42'!
initialize
	super initialize.
	rules := OrderedCollection new.! !

!CIValidator methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:43'!
manager
	^ manager! !

!CIValidator methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 21:43'!
manager: anObject
	manager := anObject! !

!CIValidator methodsFor: 'publishing' stamp: 'CamilloBruni 4/15/2013 10:29'!
publishBeforeValidation: aCIChange.
	^ self publisher publishBeforeValidation: aCIChange.! !

!CIValidator methodsFor: 'publishing' stamp: 'CamilloBruni 4/15/2013 10:29'!
publishChangeNotFound: aCIChange.
	^ self publisher publishChangeNotFound: aCIChange.! !

!CIValidator methodsFor: 'publishing' stamp: 'CamilloBruni 4/25/2013 21:02'!
publishIntermediateResult: aValidationResult
	^ self publisher publishIntermediateResult: aValidationResult! !

!CIValidator methodsFor: 'publishing' stamp: 'CamilloBruni 4/15/2013 10:29'!
publishValidationResult: aValidationResult
	^ self publisher publishValidationResult: aValidationResult! !

!CIValidator methodsFor: 'accessing' stamp: 'CamilloBruni 4/14/2013 22:48'!
publisher
	^ self manager publisher! !

!CIValidator methodsFor: 'accessing' stamp: 'CamilloBruni 4/9/2013 14:43'!
rules
	^ rules! !

!CIValidator methodsFor: 'validation' stamp: 'CamilloBruni 4/29/2013 15:09'!
validateChange: aCIChange
	| result |
	self asertLoadable: aCIChange.
	self publishBeforeValidation: aCIChange.
	
	result := CIValidationResult change: aCIChange.
	
	[ self rules do: [ :validationRule | | newResult |
		newResult := (validationRule validate: aCIChange).
		self publishIntermediateResult: newResult.
		result := result, newResult ].
	] ensure: [ 
		self publishValidationResult: result ].
	
	^ result! !

Object subclass: #ImageWorker
	instanceVariableNames: 'localPort remotePort forkedImageName remote session localServer forkedImageProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core-Validation'!

!ImageWorker commentStamp: '<historical>' prior: 0!
An ImageWorker is the new image forker stuff. It will use Seamless stuff to communicate with the forked image.

Example : 

a := ImageWorker new.
b:= a evaluate: [ 1+2 ].
b inspect.!

!ImageWorker class methodsFor: 'image-evaluation' stamp: 'CamilloBruni 5/23/2013 12:14'!
evaluate: aBlock
	| worker result |
	worker := self new.
	[ result := worker evaluate: aBlock ]
		ensure: [ worker close ].
	^ result! !

!ImageWorker class methodsFor: 'image-evaluation' stamp: 'CamilloBruni 5/23/2013 12:09'!
evaluateFromForkedImage: aBlock
	Transcript cr; show: 'evaluation of block'.
	^ aBlock asLocalObject value! !

!ImageWorker methodsFor: 'assertion' stamp: 'ErwanDouaille 5/22/2013 08:43'!
checkFileCreation
	
	self 
		assert: self temporaryChangesFile exists  
		description: self temporaryChangesFile basename, ' doesn''t exist'.
	self 
		assert: self temporaryImageFile exists 
		description: self temporaryImageFile basename, ' doesn''t exist'.! !

!ImageWorker methodsFor: 'image-creation' stamp: 'CamilloBruni 5/23/2013 12:19'!
close
	self
		closeRemoveImage;
		removeForkedImageFiles;
		closeCommunication! !

!ImageWorker methodsFor: 'image-communication' stamp: 'CamilloBruni 5/23/2013 12:16'!
closeCommunication
	
	localServer stop.! !

!ImageWorker methodsFor: 'image-creation' stamp: 'ErwanDouaille 5/22/2013 08:38'!
createForkedImage
	
	self createNewImageName.
	self launchNewImage.! !

!ImageWorker methodsFor: 'image-creation' stamp: 'CamilloBruni 5/23/2013 12:11'!
createNewImageName
	self forkedImageName: (Smalltalk imageFile nextVersion basenameWithoutExtension, '_fork').
	session := Smalltalk session.
	Smalltalk backupTo: self forkedImageName.
	self isForkedImage
		ifTrue: [ 
			"shut down the current process to avoid side-effects"
			"Processor activeProcess terminate "].
	self checkFileCreation! !

!ImageWorker methodsFor: 'image-evaluation' stamp: 'CamilloBruni 5/23/2013 12:09'!
evaluate: aBlock
	self isForkedImage 
		ifFalse: [ 
			(self remote at:#Object) new; inform: 'i''m working !!'.
			1 halt.
			^ (self remote at:#ImageWorker) evaluateFromForkedImage: aBlock ]! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:43'!
forkedImageName
	^ forkedImageName! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:43'!
forkedImageName: anObject
	forkedImageName := anObject! !

!ImageWorker methodsFor: 'initialize-release' stamp: 'CamilloBruni 5/23/2013 11:51'!
initialize

	self localPort: 10800.
	self remotePort: 10801.
	self createForkedImage.
	self initializeCommunication.! !

!ImageWorker methodsFor: 'image-communication' stamp: 'CamilloBruni 5/23/2013 12:10'!
initializeCommunication
	1000 milliSeconds wait.
	self remote: 
		(self startLocalServer connectOn: '127.0.0.1:', self remotePort asString) ! !

!ImageWorker methodsFor: 'assertion' stamp: 'ErwanDouaille 5/22/2013 15:43'!
isForkedImage
	^ (session = Smalltalk session) not! !

!ImageWorker methodsFor: 'image-forking' stamp: 'CamilloBruni 5/23/2013 12:17'!
launchNewImage
	self isForkedImage 
		ifFalse: [
			forkedImageProcess := OSProcess command: 
				Smalltalk vm command, 
				' ', 
				self temporaryImageFile fullName, 
				' seamless ', 
				self remotePort asString ]
	
	"
	it will not be a forked image since we have seamless comm Unmatched string quote ->andline handlers
	PipeableOSProcess command: temporaryImageCommand.
	self waitingForkedImageMessage."! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:35'!
localPort
	^ localPort! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:35'!
localPort: anObject
	localPort := anObject! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 09:48'!
remote
	^ remote! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 09:48'!
remote: anObject
	remote := anObject! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:35'!
remotePort
	^ remotePort! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:35'!
remotePort: anObject
	remotePort := anObject! !

!ImageWorker methodsFor: 'image-communication' stamp: 'CamilloBruni 5/23/2013 12:15'!
startLocalServer

	^ localServer := SeamlessDeamon newDefaultWithGlobalAccess startOn: self localPort ! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:44'!
temporaryChangesFile
	"return the FileReference to the newly created test image "
	^ Smalltalk fileForChangesNamed: self forkedImageName ! !

!ImageWorker methodsFor: 'accessing' stamp: 'ErwanDouaille 5/22/2013 08:44'!
temporaryImageFile
	"return the FileReference to the newly created test image "
	^ Smalltalk fileForImageNamed: self forkedImageName ! !

Object subclass: #PenelopeTheMonkey
	instanceVariableNames: 'googleTracker fogBugzTracker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!PenelopeTheMonkey commentStamp: '<historical>' prior: 0!
A CIAbstractIssueSource is an API than you have to use with an issue source.
The IssueChecker communicates with an issue source to get sources that can be loaded or validated.!

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'EstebanLorenzano 2/25/2013 16:33'!
allIssues
	| issues |
	
	"try issues which are not already migrated"
	issues := self googleTracker issuesWithParams: self nextIssueParams.
	issues ifEmpty: [ ^ nil ].
	
	^ (issues sorted: [ :a :b | a id < b id ])! !

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'BenjaminVanRyseghem 3/5/2013 23:42'!
ensureMilestoneFrom: start to: stop
	| errors |
	
	errors := OrderedCollection new.

	'Ensuring Milestones'
	displayProgressFrom: start to: stop
	during: [:bar |
		start to: stop do: [:idx || issue |
			bar value: idx.
			[ 
				issue := self googleTracker issue: idx.
				bar title: 'Ensuring Milestone for ', issue id asString, ': ', issue title.
				issue hasBeenAlreadyMigrated
					ifTrue: [ 
						[ issue ensureMilestoneFor: self fogBugzTracker ]
						on: Error 
						do: [ errors add: issue ]]]
				on: SubscriptOutOfBounds 
				do: []]].
	
	errors isEmpty
		ifFalse: [ self halt ].
	^ errors! !

!PenelopeTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/5/2013 11:10'!
fogBugzTracker

	^ fogBugzTracker ifNil: [ fogBugzTracker :=  FogBugzTracker penelope ]! !

!PenelopeTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 3/2/2013 13:50'!
googleTracker

	^ googleTracker ifNil: [ googleTracker := GoogleIssueTracker pharo 
														ulysse;
														yourself ]! !

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'BenjaminVanRyseghem 3/2/2013 13:55'!
migrateAll

	self migrateFrom: 1 to: 7623! !

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'BenjaminVanRyseghem 3/4/2013 23:59'!
migrateFrom: start to: stop
	| errors |
	
	errors := OrderedCollection new.

	'Migrating issues'
	displayProgressFrom: start to: stop
	during: [:bar |
		start to: stop do: [:idx || issue |
			bar value: idx.
			[ 
				issue := self googleTracker issue: idx.
				bar title: 'Migrating ', issue id asString, ': ', issue title.
				issue hasBeenAlreadyMigrated
					ifFalse: [ 
						[ issue migrateToFogBugzWith: self fogBugzTracker ]
						on: Error 
						do: [ errors add: issue ]]]
				on: SubscriptOutOfBounds 
				do: []]].
	
	errors isEmpty
		ifFalse: [ self halt ].
	^ errors! !

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'BenjaminVanRyseghem 3/9/2013 13:09'!
migrateIssues: aCollection
	| size errors |
	
	size := aCollection size.
	errors := OrderedCollection new.

	'Migrating issues'
	displayProgressFrom: 0 
	to: size
	during: [:bar |
		aCollection doWithIndex: [:idx :barIdx || issue |
			bar value: barIdx.
			[ 
				issue := self googleTracker issue: idx.
				bar title: 'Migrating ', issue id asString, ': ', issue title.
				issue hasBeenAlreadyMigrated
					ifFalse: [ 
						[ issue migrateToFogBugzWith: self fogBugzTracker ]
						on: Error 
						do: [ errors add: issue ]]]
				on: SubscriptOutOfBounds 
				do: []]].
	
	errors isEmpty
		ifFalse: [ self halt ].
	^ errors! !

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'EstebanLorenzano 2/25/2013 16:33'!
nextIssue
	"choose the next issue to check by Penelope"
	
	^ self allIssues first! !

!PenelopeTheMonkey methodsFor: 'private' stamp: 'BenjaminVanRyseghem 3/2/2013 13:51'!
nextIssueParams

	^ String streamContents: [ :s |
		s 
			<< 'can=all'
			<< '&q=-MigratedToFogBugz' ]! !

!PenelopeTheMonkey methodsFor: 'migrating' stamp: 'BenjaminVanRyseghem 3/9/2013 17:01'!
preventCommentsFrom: start to: stop
	| errors |
	
	errors := OrderedCollection new.

	'Migrating issues'
	displayProgressFrom: start to: stop
	during: [:bar |
		start to: stop do: [:idx || issue |
			bar value: idx.
			[ 
				issue := self googleTracker issue: idx.
				bar title: 'Closing ', issue id asString, ': ', issue title.
				issue hasBeenAlreadyClosed
					ifFalse: [ 
						[ issue preventComment ]
						on: Error 
						do: [:ex | errors add: (ex->issue) ]]]
				on: SubscriptOutOfBounds 
				do: []]].
	
	errors isEmpty
		ifFalse: [ self halt ].
		
	^ errors! !

Object subclass: #PharoTrackerLabels
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!PharoTrackerLabels commentStamp: '<historical>' prior: 0!
I contain the labels for the google issue tracker entries!

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:38'!
accepted

	^ #Accepted! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/30/2012 17:13'!
issueChecked

	^ #ValidatedByTheMonkey! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
noSourcesAvailable

	^ #NoSourcesAvailable! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
reviewNeeded

	^ #FixReviewNeeded! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'ClementBEra 1/30/2013 15:38'!
testFailure

	^ #'WorkNeeded-FailingTest'! !

!PharoTrackerLabels class methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 6/29/2012 15:17'!
workNeeded

	^ #WorkNeeded! !

Object subclass: #SliceSubmitter
	instanceVariableNames: 'issue mcPackage receiver'
	classVariableNames: 'tracker'
	poolDictionaries: ''
	category: 'CI-Core-SliceSubmitter'!

!SliceSubmitter commentStamp: '<historical>' prior: 0!
SliceSubmitter is a tool made to submit slice easily be automaticcaly creating the issue on GoogleIssueTracker!

!SliceSubmitter class methodsFor: 'authentification' stamp: 'BenjaminVanRyseghem 7/4/2012 15:19'!
authenticate: user with: password 

	tracker := GoogleIssueTracker pharo.
	tracker authenticate: user with: password! !

!SliceSubmitter class methodsFor: 'nautilus menu' stamp: 'EstebanLorenzano 1/30/2013 15:52'!
buildNautilusMenu: aBuilder
	<nautilusGlobalPackageMenu>
	| package target mc |
	target := aBuilder model.
	(package := target selectedPackage) ifNil: [ ^self ].
	mc := NautilusMCBindings default retrieveMCPackageFor: package.
	
	mc isNil or: [ mc workingCopy modified not ifTrue: [ ^self ] ].
	(aBuilder item: #'Open new bug report and attach changes of this package')
		action: [ self new 
						receiver: target window;
						mcPackage: mc;
						submitNewSlice ];
		order: 1299.5;
		icon: UITheme current forwardIcon;
		help: 'Create a bug entry and a slice for the selected package';
		withSeparatorAfter.
	! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:44'!
commit: workingCopy in: repo message: message
	| newVersion |

	[ newVersion := workingCopy newVersion ]
		on: MCVersionNameAndMessageRequest
		do: [:n | n resume: (Array with: n suggestedName with: message)].
		
	newVersion ifNil: [ ^ self ].
	repo storeVersion: newVersion.
	repo storeDependencies: newVersion! !

!SliceSubmitter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/6/2012 16:46'!
initialize
	"Initialization code for SliceSubmitter"

	super initialize.
		
	issue := GoogleIssue new
				status: PharoTrackerLabels accepted;
				tracker: self tracker;
				yourself.
	receiver := World.
	mcPackage := nil.! !

!SliceSubmitter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/6/2012 16:47'!
initializeTracker
	| userPassword tries |

	tries := 3.
	[ userPassword isNil and: [ tries > 0] ] whileTrue: [ 
		tries := tries -1.
		userPassword := self retrieveUserPassword ].
	[ self class authenticate: userPassword key with: userPassword value ] on: Error do: [ tracker := nil ].! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:09'!
issue
	^ issue! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:15'!
mcPackage

	^ mcPackage! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:15'!
mcPackage: anObject

	mcPackage := anObject! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:45'!
postNewSlice: workingCopy message: aMessage

	workingCopy ifNil: [ ^ self ].
	self commit: workingCopy in: MCHttpRepository inboxRepository message: aMessage! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:14'!
receiver

	^ receiver! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/4/2012 16:15'!
receiver: anObject

	receiver := anObject! !

!SliceSubmitter methodsFor: 'private' stamp: 'SeanDeNigris 8/26/2012 11:59'!
repository

	^ MCHttpRepository location: 'http://ss3.gemstone.com/ss/Pharo20'.! !

!SliceSubmitter methodsFor: 'initialize' stamp: 'BenjaminVanRyseghem 7/25/2012 11:58'!
retrieveUserPassword

	| ui user password |
	
	ui := Authentifier new.
	World openModal: ui openDialogWithSpec window.
	^ ui result! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/25/2012 12:05'!
submitNewSlice
	| slice creator wc message |
	
	self tracker ifNil: [ ^ self ].
	self mcPackage ifNil: [ ^ self ].
	wc :=  self mcPackage workingCopy.
	wc modified ifFalse: [ ^ self ].
	
	(self viewChangesFor: wc)
		ifFalse: [ ^ self ].
	
	slice := MCSliceInfo new
				includedPackages: { wc };
				yourself.
				
	creator := IssueCreator new
					issue: issue;
					yourself.
	 
	self receiver openModal: creator openDialogWithSpec window.
	creator cancelled ifTrue: [ ^ self ].
	issue description ifNil: [ ^ self ]. "Something went wrong"
	message := issue description content.
	issue description: (String streamContents: [:s |
								s << message.
								s cr; cr.
								s << '-------------------';cr.
								s<< 'Slice is in the inbox']).
	[ issue submitAsNewEntry ] on: ErrorWhileCreationException do: [ ^ self ].

	slice issueNumber: issue id asString.
	slice issueSummary: issue title.
	slice := slice makeSlice.
	
	self postNewSlice: slice message: message.
	
	issue
		status: PharoTrackerLabels reviewNeeded;
		submitStatusChange! !

!SliceSubmitter methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 7/10/2012 14:02'!
tracker

	^ tracker ifNil: [ 
		self initializeTracker.
		tracker ].! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/6/2012 16:21'!
viewChanges: patch for: workingCopy from: fromDescription to: toDescription
	"Open a browser on the given patch."
	| morph |

	morph := (PSMCPatchMorph forPatch: patch)
						fromDescription: fromDescription;
						toDescription: toDescription;
						vResizing: #spaceFill;
						hResizing: #spaceFill;
						yourself.
						
	^ MorphEmbedder new
			title: ('Changes to {1}' translated format: {fromDescription});
			morph: morph;
			yourself ! !

!SliceSubmitter methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 7/18/2012 17:07'!
viewChangesFor: workingCopy
	"View the changes made in the working copy."
	
	| patch |
	'Finding changes' displayProgressFrom: 0 to: 10 during:[:bar|
		bar current: 1.
		patch := workingCopy changesRelativeToRepository: self repository.
		patch isNil ifTrue: [^ self].
		bar current: 3.
		patch isEmpty
			ifTrue: [
				workingCopy modified: false.
				bar current: 10.
				self inform: 'No changes'.
				^ false ]
			ifFalse: [ | window |
				workingCopy modified: true.
				bar current: 5.
				
				window := self
					viewChanges: patch
					for: workingCopy
					from: workingCopy  packageName, ' (', workingCopy ancestry ancestorString, ')'
					to: ('Modified {1}' translated format: {workingCopy description}).
				self receiver openModal: window openDialogWithSpec window.
				^ window result ]]! !

Object subclass: #UlysseTheMonkey
	instanceVariableNames: 'tracker previousTestResult loadStopwatch testStopwatch extraTests errors testErrors testFailures testResult issue verbose debug'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CI-Core'!

!UlysseTheMonkey commentStamp: '<historical>' prior: 0!
A UlysseTheMonkey is an intergalactikal monkey who is coming from outer space to check the fix proposed in the google issue tracker.

Do NOT mess with Ulysse !!!!!

!UlysseTheMonkey class methodsFor: 'example' stamp: 'CamilloBruni 9/22/2011 19:47'!
example
	| tracker changeLoader issue |
	
	tracker := GoogleIssueTracker pharo.
	
	tracker authenticate: 'USERNAME@gmail.com' with: 'PASSWORD'.

	issue := tracker issue: 4839.
	
	changeLoader := issue load! !

!UlysseTheMonkey class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/21/2011 14:37'!
issue: issue

	^ self new
		issue: issue;
		yourself! !

!UlysseTheMonkey class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 9/21/2011 01:34'!
tracker: tracker

	^ self new
		tracker: tracker;
		yourself! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/22/2011 21:16'!
addError: anError
	
	^ self addError: anError forFile: nil! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'MonkeyGalactikalIntegrator 12/16/2011 16:56'!
addError: anError forFile: aFileNameString

	|index|
	
	index := 1.
	
	errors add:(String streamContents: [ :stream|
		aFileNameString ifNotNil: [ 
			stream << 'Error while loading ' << aFileNameString << ':'; lf].
		stream tab print: anError; lf.
		(anError signalerContext contextStack first: 10) do: [ :context|
			stream << (index asString padded: #left to: 2 with: $ ); << ':'; tab.
			"indent the error string"
			stream << (context asString copyReplaceAll: String cr with: String lf, String tab); lf.
			index := index + 1].
		stream tab << '...'])! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 1/20/2012 20:29'!
buildErrorReportOn: stream

	errors isEmpty ifTrue: [ ^ self ].
	
	stream nextPutAll: 'Monkey went bananas:'; lf.
	
	errors 
		do: [:e | 
			stream nextPutAll: '--------------------'; lf.
			stream nextPutAll: e ]
		separatedBy: [ stream lf lf]
			! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/30/2011 14:12'!
buildGreenChangesOn: aStream

	self flag: 'print the recorded changes '.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/23/2011 15:38'!
buildGreenReport

	^ String streamContents: [:stream | self buildGreenReportOn: stream ]! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/30/2011 14:12'!
buildGreenReportOn: stream

	| packages |
	
	testResult ifNil: [ ^ self ].
	
	self buildGreenTitleOn: stream.
	self buildGreenTestResultsOn: stream.
	self buildGreenChangesOn: stream.
	self buildSetupDescriptionOn: stream.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'MonkeyGalactikalIntegrator 1/25/2012 00:21'!
buildGreenTestResultsOn: stream
	|packages|
	
	"count the number of tests per package"
	packages := Dictionary new.
	testResult passed do: [ :testCase| | package |
		package := testCase class category.
		packages at: package put: (packages at: package ifAbsent: [ 0 ]) + 1 ].
	
	packages keys asArray sort do: [ :package|
		stream tab; nextPutAll: package; nextPutAll: ' ('; print: (packages at: package); nextPutAll: ')'; lf].
	
	stream lf.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 1/20/2012 20:29'!
buildGreenTitleOn: aStream 
	|duration title|
	
	duration := testStopwatch duration.
	
	title :=  String streamContents: [ :s |
					s << testResult passed size asString << ' tests passed in '.
					s << (duration hours asString padded: #left to: 2 with: $0) << ':'.
					s << (duration minutes asString padded: #left to: 2 with: $0) << ':'.
					s << (duration seconds asString padded: #left to: 2 with: $0) << 's:'].
				
	aStream << title; lf.
	title size timesRepeat: [ aStream nextPutAll: '='].
	aStream lf.
	! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/23/2011 15:38'!
buildRedReport

	^ String streamContents: [:stream | self buildRedReportOn: stream ]! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 9/25/2011 05:06'!
buildRedReportOn: stream
	
	self buildErrorReportOn: stream.
	self buildTestsReportOn: stream.
	
	stream lf.
	self buildSetupDescriptionOn: stream.! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CamilloBruni 1/20/2012 20:28'!
buildSetupDescriptionOn: aStream
	
	aStream nextPutAll: '----------------------------------------------------------'; lf.
	aStream nextPutAll: 'Loaded Source: '.
	
	self issue hasSlice ifTrue: [ 
		aStream 
			nextPutAll: self slice name;
			nextPutAll: ' from ';
			nextPutAll: self slice repository description ].
		
	self issue hasChangeSet
		ifTrue: [
			self issue changeSets size > 1 ifTrue: [ aStream lf tab ].
			self issue changeSets 
					do: [ :attachment|  aStream nextPutAll: attachment description ]
					separatedBy: [ aStream lf tab ]].
		
	aStream lf;
		nextPutAll: 'Tested using '; nextPutAll: SystemVersion current imageVersionString;
		nextPutAll: ' on '; nextPutAll: Smalltalk vm version! !

!UlysseTheMonkey methodsFor: 'printing' stamp: 'CAmilloBruni 7/19/2012 15:45'!
buildTestsReportOn: stream
	
	(testErrors isEmptyOrNil and: [ testFailures isEmptyOrNil])
		ifTrue: [ ^ self ].
	
	stream nextPutAll: 'Test Results:'; lf.
	stream nextPutAll: '-------------'; lf.
			
	stream nextPutAll: 'Passed: '; print: testResult passed size; lf.
	self buildGreenTestResultsOn: stream.
	
	testErrors ifNotEmpty: [:collection |
		stream nextPutAll: 'Errors: '; print: collection size; lf.
		collection do: [:e | stream tab print: e; lf ]].
	
	stream lf.
		
	testFailures ifNotEmpty: [:collection |
		stream nextPutAll: 'Failures: '; print: collection size; lf.
		collection do: [:e | stream tab print: e; lf ]]! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 7/2/2012 16:28'!
coreTests
	
	^ self class environment allClasses select: [:class | 
		{'SUnit'. 'CompilerTests'. 'CollectionsTests'. 'KernelTests'} 
			anySatisfy: [:packageName | 
				class category beginsWith: packageName ]].! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 9/5/2012 15:31'!
debug
	debug := true! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'CamilloBruni 9/5/2012 15:31'!
debug: anError
	debug ifTrue: [ anError debug ].! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/26/2011 19:01'!
dirtyPackagesTests
				
	^ self issue dirtyPackagesTests! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/25/2011 17:07'!
errorNoLoadableSources
	
	"Error signal: 'Issue has no loadable sources attached'."
	
	self issue errorNoSources! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/22/2011 16:13'!
extraTests

	^ extraTests! !

!UlysseTheMonkey methodsFor: 'process' stamp: 'CamilloBruni 2/15/2013 00:24'!
foundIssuesToCheck

	^ self tracker openIssues select: [:e | e hasToBeChecked ]! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'BenjaminVanRyseghem 6/29/2012 15:28'!
ifGreen: greenBlock ifErrors: errorBlock ifTestFailing: testBlock

	self isGreen ifTrue: [ ^ greenBlock value ].

	^ errors isEmpty
		ifTrue: testBlock 
		ifFalse: errorBlock ! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'BenjaminVanRyseghem 9/26/2011 18:27'!
impactedPackagesTests
			
	^ self issue impactedPackagesTests! !

!UlysseTheMonkey methodsFor: 'initialize' stamp: 'CamilloBruni 2/15/2013 00:16'!
initialize
	verbose := true.
	debug := false.
	self reset.! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/23/2011 15:38'!
isAllGreen

	self runAllTests.
	^ testResult hasPassed! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'EstebanLorenzano 8/17/2012 16:41'!
isCog

	^ Smalltalk vm version includesSubstring: 'Cog'! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/23/2011 16:19'!
isGreen
	^  errors isEmpty and: [ testFailures isEmptyOrNil and: [ testErrors isEmptyOrNil ]]! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/16/2011 10:04'!
isVerbose
	^ verbose! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:10'!
issue

	^ issue! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 9/22/2011 13:53'!
issue: anIssue
	
	issue := anIssue.! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'CamilloBruni 9/30/2011 18:32'!
load
	"simply load a slice or changesets associated with the issue.
	Note: this does NOT updae the issue tracker, see loadAndTest for this"
	
	self issue hasSlice ifTrue: [ ^ self loadSlice ].
	self issue hasChangeSet ifTrue: [ ^ self loadChangeSet ].

	"Here we assume the check has already be done by the issue"! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 9/25/2011 17:51'!
loadAndTest
	"load the changesets or the slice for the issue and run tests.
	Note this will update directly notify the issue tracker and add comments."
	
	self issue hasSlice ifTrue: [ ^ self loadAndTestSlice ].
	self issue hasChangeSet ifTrue: [ ^ self loadAndTestChangeSet ].
	
	"Here I assume the check have already been done by the issue itself"! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'CamilloBruni 9/23/2011 15:27'!
loadAndTestChangeSet
	"load the changesets and run the test"
	
	self issue changeSets ifEmpty: [ ^ self ].
	
	self testChangeImpact: [ self loadChangeSet ].! !

!UlysseTheMonkey methodsFor: 'protocol' stamp: 'CamilloBruni 9/25/2011 05:04'!
loadAndTestSlice
	"Load slice and run tests"
	
	self issue hasSlice ifFalse: [ ^ self ].
	
	self testChangeImpact: [ self loadSlice ].
	! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'CamilloBruni 9/5/2012 15:30'!
loadChangeSet
	"load the changeset(s) for the issue"
	
	self flag: 'TODO: record the adds/changes/removes per package'.
	
	self issue changeSets do: [ :attachment | 
		 [ attachment contents asString readStream fileIn ] 
			on: Error 
			do: [ :e| 
				self addError: e forFile: attachment description.
				self debug: e ]].
		
	self extraTests addAll: self dirtyPackagesTests.! !

!UlysseTheMonkey methodsFor: 'private' stamp: 'CamilloBruni 9/5/2012 15:31'!
loadSlice
	"load the slice for the set issue"
	
	self flag: 'TODO: record the adds/changes/removes per package'.
	
	[ self slice merge ]
		on: Error, Warning
		do: [ :e| 
			self 
				addError: e 
				forFile: (self slice name, ' from ', self slice repository description);
				debug: e ]! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/4/2012 23:20'!
notifyTracker
	self isVerbose ifFalse: [ ^ self ].
	
	self 
		ifGreen: [ self issue fixToInclude: self buildGreenReport ]
		ifErrors: [ self issue reviewNeeded: self buildRedReport ]
		ifTestFailing: [ self issue failingTest: self buildRedReport ]! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 2/15/2013 00:12'!
preRunTests
	
	" I run tests a first time to be able to remove false errors later"
	previousTestResult := self runAllTests.! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/16/2011 10:04'!
quiet
	verbose := false! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 9/25/2011 03:54'!
removeCriticalTestsFrom: aTestSuite
	
	{
		MethodContextTest>>#testClosureRestart. 
		AllocationTest>>#testOneGigAllocation.
		SizeInMemoryTest>>#testSizeInMemoryClasses
	} do: [ :method|
		(aTestSuite tests
				detect: [ :testCase| 
						testCase class = method methodClass and: [ testCase selector = method selector ]] 
				ifNone: [ nil ])
			ifNotNil: [:testCase| aTestSuite tests remove: testCase ]].
	
	^ aTestSuite! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 4/29/2013 21:05'!
removeFalsePositives

	testFailures := #().
	testErrors := #().
	testResult ifNil: [ ^ self ].
	
	testFailures := testResult failures reject:[: each || detected |
		detected := previousTestResult failures detect: [:e2 | each name = e2 name ] ifNone: [nil].
		detected ifNil: [ false ] ifNotNil: [ each selector = detected selector ]].
	
	
	testErrors := testResult errors reject:[: each || detected |
		detected := previousTestResult errors detect: [:e2 | each name = e2 name ] ifNone: [nil].
		detected ifNil: [ false ] ifNotNil: [ each selector = detected selector ]].
	! !

!UlysseTheMonkey methodsFor: 'initialize' stamp: 'CamilloBruni 9/23/2011 15:36'!
reset
	
	errors := Set new.
	extraTests := Set new.
	loadStopwatch := Stopwatch new.
	testStopwatch := Stopwatch new.! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 2/15/2013 14:46'!
runAllTests
	
	|suite|
	
	suite := TestSuite new.
	
	TestCase allSubclasses do: [ :testClass|
		testClass isAbstract ifFalse: [ suite addTests: testClass suite tests ]].
	
	^ testResult := suite run.! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/25/2011 02:36'!
slice

	^ self issue slice! !

!UlysseTheMonkey methodsFor: 'testing' stamp: 'CamilloBruni 4/29/2013 21:05'!
testChangeImpact: aBlock
	| complete |
	
	"run the issue update requests in the background to save some time"
	complete := Semaphore new.
	[
		self isVerbose ifTrue: [ self issue monkeyIsChecking ].
		complete signal
	] fork.
				
	self preRunTests.
	[
		loadStopwatch reset activate.
		"here I load the code"
		aBlock value.
		loadStopwatch suspend.

		"Then I re run tests"
		testResult := self runAllTests.
		self removeFalsePositives.
		
	"collect possible errors"
	] on: Error do: [ :e| self addError: e ].
	
	"wait for the initial issue update to be completed"
	complete wait.
	"update the issue with load/test results"
	self notifyTracker.! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:10'!
testResult

	^ testResult! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 17:10'!
testResult: anObject

	testResult := anObject! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 2/15/2013 00:19'!
tracker
	^ tracker! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 9/21/2011 01:34'!
tracker: anObject
	
	tracker := anObject! !

!UlysseTheMonkey methodsFor: 'accessing' stamp: 'CamilloBruni 12/16/2011 10:04'!
verbose
	verbose := true! !
